/**
  * Details of class Point
*/
public class Point {

    // Fields
    protected double x;
    protected double y;
    protected double distance;

    // Constructor
    Point () {
        setX(0);
        setY(0);
    }

    Point (double x, double y) {
        setX(x);
        setY(y);
    }

    // Methods
    public void setX (double x) {
        this.x = x;
        updateDistance();
    }

    public void setY (double y) {
        this.y = y;
        updateDistance();
    }

    public double x () {
        return x;
    }

    public double y () {
        return y;
    }

    public double distanceFromOrigin () {
        return distance;
    }

    public String toString() {
        return "<" + x + "," + y + ">";
    }

    // Internal methods
    protected void updateDistance () {
        distance = Math.sqrt(x*x + y*y);
    }
} 
