import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import foundations.*;

public class StackQueueUI extends JFrame {
    JComboBox containerType = new JComboBox();
    JPanel constructPanel = new JPanel();
    JLabel constructLbl = new JLabel();
    JButton construct = new JButton();
    JPanel commandsPanel = new JPanel();
    JButton addBtn = new JButton();
    JButton removeBtn = new JButton();
    JButton makeEmptyBtn = new JButton();
    JTextField addValue = new JTextField();
    JLabel commandsLbl = new JLabel();
    JButton size = new JButton();
    JPanel queriesPanel = new JPanel();
    JTextField frontValue = new JTextField();
    JButton isEmpty = new JButton();
    JButton frontBtn = new JButton();
    JLabel queriesLbl = new JLabel();
    JLabel jLabel4 = new JLabel();

    // Fields
    private ArrayStack arrayStack = new ArrayStack(1000);
    private LinkedStack linkedStack = new LinkedStack();
    private LinkedQueue linkedQueue = new LinkedQueue();
    JTextField isEmptyText = new JTextField();
    JTextField sizeText = new JTextField();
    JScrollPane jScrollPane1 = new JScrollPane();
    JTextArea textArea = new JTextArea();
    JButton reset = new JButton();

    //Construct the frame
    public StackQueueUI() {
        enableEvents(AWTEvent.WINDOW_EVENT_MASK);
        try  {
            jbInit();
        }
        catch (Exception e) {
            e.printStackTrace();
        }
    }
    
    //Component initialization
    private void jbInit() throws Exception  {
        this.getContentPane().setLayout(null);
        this.setSize(new Dimension(595, 557));
        this.addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowOpened(WindowEvent e) {
                this_windowOpened(e);
            }
        });
        containerType.setToolTipText("Select stack or queue type");
        containerType.setBounds(new Rectangle(13, 13, 119, 24));
        constructPanel.setBackground(new Color(255, 255, 192));
        constructPanel.setLayout(null);
        constructPanel.setBounds(new Rectangle(13, 75, 215, 94));
        constructLbl.setText("Construct Data Structure");
        constructLbl.setBounds(new Rectangle(53, 55, 134, 15));
        construct.setText("Invoke Constructor");
        construct.setOpaque(true);
        construct.setBounds(new Rectangle(36, 14, 143, 23));
        construct.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                construct_actionPerformed(e);
            }
        });
        commandsPanel.setBackground(new Color(255, 255, 192));
        commandsPanel.setLayout(null);
        commandsPanel.setBounds(new Rectangle(8, 205, 217, 139));
        addBtn.setOpaque(true);
        addBtn.setBounds(new Rectangle(12, 16, 99, 23));
        addBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                addBtn_actionPerformed(e);
            }
        });
        removeBtn.setOpaque(true);
        removeBtn.setBounds(new Rectangle(12, 61, 99, 23));
        removeBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                removeBtn_actionPerformed(e);
            }
        });
        makeEmptyBtn.setText("makeEmpty");
        makeEmptyBtn.setOpaque(true);
        makeEmptyBtn.setBounds(new Rectangle(12, 106, 99, 23));
        makeEmptyBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                makeEmptyBtn_actionPerformed(e);
            }
        });
        addValue.setBounds(new Rectangle(137, 18, 63, 19));
        commandsLbl.setText("Commands");
        commandsLbl.setBounds(new Rectangle(78, 185, 76, 15));
        size.setText("size");
        size.setOpaque(true);
        size.setBounds(new Rectangle(11, 98, 91, 23));
        size.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                size_actionPerformed(e);
            }
        });
        queriesPanel.setBackground(new Color(255, 255, 192));
        queriesPanel.setLayout(null);
        queriesPanel.setBounds(new Rectangle(8, 375, 217, 139));
        jLabel4.setText("Event Log");
        jLabel4.setBounds(new Rectangle(364, 57, 72, 15));
        isEmptyText.setEditable(false);
        isEmptyText.setBounds(new Rectangle(130, 56, 63, 19));
        sizeText.setEditable(false);
        sizeText.setBounds(new Rectangle(130, 100, 63, 19));
        jScrollPane1.setBounds(new Rectangle(238, 75, 337, 441));
        textArea.setBounds(new Rectangle(238, 75, 333, 437));
        reset.setText("Reset");
        reset.setOpaque(true);
        reset.setBounds(new Rectangle(36, 59, 143, 23));
        reset.addActionListener(new java.awt.event.ActionListener() {

      	public void actionPerformed(ActionEvent e) {
        	reset_actionPerformed(e);
      	}});
      	
        frontValue.setEditable(false);
        frontValue.setBounds(new Rectangle(130, 11, 63, 19));
        isEmpty.setText("isEmpty");
        isEmpty.setOpaque(true);
        isEmpty.setBounds(new Rectangle(11, 54, 91, 23));
        isEmpty.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                isEmpty_actionPerformed(e);
            }
        });
        frontBtn.setOpaque(true);
        frontBtn.setBounds(new Rectangle(11, 9, 91, 23));
        frontBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                frontBtn_actionPerformed(e);
            }
        });
        queriesLbl.setText("Queries");
        queriesLbl.setBounds(new Rectangle(86, 356, 60, 15));
        this.setTitle("Stack Queue Lab");
        this.getContentPane().add(containerType, null);
        this.getContentPane().add(constructPanel, null);
    	constructPanel.add(construct, null);
    	constructPanel.add(reset, null);
        this.getContentPane().add(constructLbl, null);
        this.getContentPane().add(commandsPanel, null);
        commandsPanel.add(addBtn, null);
        commandsPanel.add(removeBtn, null);
        commandsPanel.add(makeEmptyBtn, null);
        commandsPanel.add(addValue, null);
        this.getContentPane().add(commandsLbl, null);
        this.getContentPane().add(queriesPanel, null);
        queriesPanel.add(isEmpty, null);
        queriesPanel.add(size, null);
        queriesPanel.add(frontValue, null);
        queriesPanel.add(frontBtn, null);
        queriesPanel.add(isEmptyText, null);
        queriesPanel.add(sizeText, null);
        this.getContentPane().add(queriesLbl, null);
        this.getContentPane().add(jLabel4, null);
        this.getContentPane().add(jScrollPane1, null);
        this.getContentPane().add(textArea, null);
        jScrollPane1.getViewport().add(textArea, null);
    }

    //Overriden so we can exit on System Close
    protected void processWindowEvent(WindowEvent e) {
        super.processWindowEvent(e);
        if (e.getID() == WindowEvent.WINDOW_CLOSING) {
            System.exit(0);
        }
    }

    void this_windowOpened(WindowEvent e) {
        containerType.addItem("ArrayStack");
        containerType.addItem("LinkedStack");
        containerType.addItem("LinkedQueue");
        constructPanel.setVisible(true);
        constructLbl.setVisible(true);
        commandsPanel.setVisible(false);
        queriesPanel.setVisible(false);
        commandsLbl.setVisible(false);
        queriesLbl.setVisible(false);
    }

    void construct_actionPerformed(ActionEvent e) {
        containerType.setEnabled(false);
        constructLbl.setEnabled(false);
        constructPanel.setEnabled(false);
        construct.setEnabled(false);
        commandsPanel.setVisible(true);
        queriesPanel.setVisible(true);
        commandsLbl.setVisible(true);
        queriesLbl.setVisible(true);
        reset.setEnabled(true);
        if (containerType.getSelectedIndex() <= 1) {
            addBtn.setText("push");
            removeBtn.setText("pop");
            frontBtn.setText("top");
        }
        else {
            addBtn.setText("add");
            removeBtn.setText("remove");
            frontBtn.setText("front");
        }
        switch (containerType.getSelectedIndex()) {
            case 0:
                textArea.append("ArrayStack constructed\n");
                break;
            case 1:
                textArea.append("LinkedStack constructed\n");
                break;
            case 2:
                textArea.append("LinkedQueue constructed\n");
                break;
        }
    }

    void addBtn_actionPerformed(ActionEvent e) {
        if (addValue.getText().trim().length() == 0)
            JOptionPane.showMessageDialog(this, "Must enter String");
        else {
            switch (containerType.getSelectedIndex()) {
                case 0:
                    arrayStack.push(addValue.getText().trim());
                    textArea.append("push " + addValue.getText().trim() +
                                    " onto the ArrayStack\n");
                    break;
                case 1:
                    linkedStack.push(addValue.getText().trim());
                    textArea.append("push " + addValue.getText().trim() +
                                    " onto the LinkedStack\n");
                    break;
                case 2:
                    linkedQueue.add(addValue.getText().trim());
                    textArea.append("add " + addValue.getText().trim() +
                                    " onto the LinkedQueue\n");
                    break;
            }
            addValue.setText("");
            frontValue.setText("");
            isEmptyText.setText("");
            sizeText.setText("");
        }
    }

    void removeBtn_actionPerformed(ActionEvent e) {
        switch (containerType.getSelectedIndex()) {
            case 0:
                if (!arrayStack.isEmpty()) {
                    arrayStack.pop();
                    textArea.append("pop value from ArrayStack\n");
                }
                break;
            case 1:
                if (!linkedStack.isEmpty()) {
                    linkedStack.pop();
                    textArea.append("pop value from LinkedStack\n");
                }
                break;
            case 2:
                if (!linkedQueue.isEmpty()) {
                    linkedQueue.remove();
                    textArea.append("remove value from LinkedQueue\n");
                }
                break;
        }
        addValue.setText("");
        frontValue.setText("");
        isEmptyText.setText("");
        sizeText.setText("");
    }

    void makeEmptyBtn_actionPerformed(ActionEvent e) {
        switch (containerType.getSelectedIndex()) {
            case 0:
                arrayStack.makeEmpty();
                break;
            case 1:
                linkedStack.makeEmpty();
                break;
            case 2:
                linkedQueue.makeEmpty();
                break;
        }
        addValue.setText("");
        frontValue.setText("");
        isEmptyText.setText("");
        sizeText.setText("");
        textArea.append("makeEmpty\n");
    }

    void isEmpty_actionPerformed(ActionEvent e) {
        switch (containerType.getSelectedIndex()) {
            case 0:
                if (arrayStack.isEmpty())
                    isEmptyText.setText("true");
                else
                    isEmptyText.setText("false");
                break;
            case 1:
                if (linkedStack.isEmpty())
                    isEmptyText.setText("true");
                else
                    isEmptyText.setText("false");
                break;
            case 2:
                if (linkedQueue.isEmpty())
                    isEmptyText.setText("true");
                else
                    isEmptyText.setText("false");
                break;
        }
    }

    void size_actionPerformed(ActionEvent e) {
        switch (containerType.getSelectedIndex()) {
            case 0:
                sizeText.setText("" + arrayStack.size());
                break;
            case 1:
                sizeText.setText("" + linkedStack.size());
                break;
            case 2:
                sizeText.setText("" + linkedQueue.size());
                break;
        }
    }

    void frontBtn_actionPerformed(ActionEvent e) {
        switch (containerType.getSelectedIndex()) {
            case 0:
                if (!arrayStack.isEmpty())
                    frontValue.setText((String) arrayStack.top());
                break;
            case 1:
                if (!linkedStack.isEmpty())
                    frontValue.setText((String) linkedStack.top());
                break;
            case 2:
                if (!linkedQueue.isEmpty())
                    frontValue.setText((String) linkedQueue.front());
                break;
        }
    }

  void reset_actionPerformed(ActionEvent e) {
        containerType.setEnabled(true);
        constructLbl.setEnabled(true);
        constructPanel.setEnabled(true);
        construct.setEnabled(true);
        commandsPanel.setVisible(false);
        queriesPanel.setVisible(false);
        commandsLbl.setVisible(false);
        queriesLbl.setVisible(false);
        reset.setEnabled(false);
  }
}
