import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.text.*;
import foundations.*;
import java.util.*;

public class ExprEvalUI extends JFrame {
    JPanel postfixPanel = new JPanel();
    JPanel inputPanel = new JPanel();
    JPanel operandPanel = new JPanel();
    JTextField op1 = new JTextField();
    JTextField op2 = new JTextField();
    JTextField op3 = new JTextField();
    JTextField op4 = new JTextField();
    JTextField op5 = new JTextField();
    JTextField op6 = new JTextField();
    JLabel jLabel1 = new JLabel();
    JTextField infixField = new JTextField();
    JLabel jLabel2 = new JLabel();
    JLabel jLabel3 = new JLabel();
    JLabel jLabel4 = new JLabel();
    JTextField postfixField = new JTextField();
    JLabel jLabel5 = new JLabel();
    JLabel op1Lbl = new JLabel();
    JLabel op2Lbl = new JLabel();
    JLabel op3Lbl = new JLabel();
    JLabel op4Lbl = new JLabel();
    JLabel op5Lbl = new JLabel();
    JLabel op6Lbl = new JLabel();
    JButton answerBtn = new JButton();
    JLabel answerLbl = new JLabel();

    // Fields
    VectorDictionary dictionary = new VectorDictionary();
    int numOperands = 0;
    FunctionEvaluation f;

    //Construct the frame
    public ExprEvalUI() {
        enableEvents(AWTEvent.WINDOW_EVENT_MASK);
        try  {
            jbInit();
        }
        catch (Exception e) {
            e.printStackTrace();
        }
    }

    //Component initialization
    private void jbInit() throws Exception  {
        this.getContentPane().setLayout(null);
        this.setSize(new Dimension(730, 504));
        this.addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowOpened(WindowEvent e) {
                this_windowOpened(e);
            }
        });
        postfixPanel.setBounds(new Rectangle(16, 246, 445, 210));
        inputPanel.setBackground(new Color(255, 255, 192));
        inputPanel.setLayout(null);
        inputPanel.setBounds(new Rectangle(15, 13, 445, 210));
        operandPanel.setBackground(new Color(255, 255, 192));
        operandPanel.setLayout(null);
        operandPanel.setBounds(new Rectangle(479, 13, 231, 444));
        op1.setBounds(new Rectangle(73, 70, 63, 19));
        op2.setBounds(new Rectangle(73, 127, 63, 19));
        op3.setBounds(new Rectangle(73, 184, 63, 19));
        op4.setBounds(new Rectangle(73, 241, 63, 19));
        op5.setBounds(new Rectangle(73, 298, 63, 19));
        op6.setBounds(new Rectangle(73, 355, 63, 19));
        infixField.setBounds(new Rectangle(62, 114, 321, 19));
        infixField.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(KeyEvent e) {
                infixField_keyPressed(e);
            }
        });
        jLabel2.setText("Any single alphabetic character may be used as an operand.");
        jLabel2.setBounds(new Rectangle(54, 28, 336, 15));
        jLabel3.setText("A maximum of six operands may be used in an expression.");
        jLabel3.setBounds(new Rectangle(57, 56, 330, 15));
        jLabel4.setText("Input algebraic expression (CR to terminate)");
        jLabel4.setForeground(Color.red);
        jLabel4.setBounds(new Rectangle(98, 93, 248, 15));
        postfixField.setEditable(false);
        postfixField.setBounds(new Rectangle(62, 95, 321, 19));
        jLabel5.setText("Postfix expression");
        jLabel5.setForeground(Color.red);
        jLabel5.setBounds(new Rectangle(169, 76, 106, 15));
        op1Lbl.setText("Operand");
        op1Lbl.setBounds(new Rectangle(73, 53, 61, 15));
        op2Lbl.setBounds(new Rectangle(73, 110, 61, 15));
        op3Lbl.setBounds(new Rectangle(73, 165, 61, 15));
        op4Lbl.setBounds(new Rectangle(73, 225, 61, 15));
        op5Lbl.setBounds(new Rectangle(73, 280, 61, 15));
        op6Lbl.setBounds(new Rectangle(73, 337, 61, 15));
        answerBtn.setText("Answer");
        answerBtn.setOpaque(true);
        answerBtn.setBounds(new Rectangle(73, 389, 125, 23));
        answerBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                answerBtn_actionPerformed(e);
            }
        });
        answerLbl.setText("Answer: ");
        answerLbl.setBounds(new Rectangle(75, 421, 127, 15));
        op6Lbl.setText("Operand");
        op5Lbl.setText("Operand");
        op4Lbl.setText("Operand");
        op3Lbl.setText("Operand");
        op2Lbl.setText("Operand");
        op6.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                op6_actionPerformed(e);
            }
        });
        jLabel1.setText("Input Values");
        jLabel1.setBounds(new Rectangle(69, 29, 99, 15));
        postfixPanel.setBackground(new Color(255, 255, 192));
        postfixPanel.setLayout(null);
        this.setTitle("Expression Evaluation Lab");
        this.getContentPane().add(postfixPanel, null);
        postfixPanel.add(postfixField, null);
        postfixPanel.add(jLabel5, null);
        this.getContentPane().add(inputPanel, null);
        inputPanel.add(infixField, null);
        inputPanel.add(jLabel2, null);
        inputPanel.add(jLabel3, null);
        inputPanel.add(jLabel4, null);
        this.getContentPane().add(operandPanel, null);
        operandPanel.add(op1, null);
        operandPanel.add(op2, null);
        operandPanel.add(op3, null);
        operandPanel.add(op4, null);
        operandPanel.add(op5, null);
        operandPanel.add(op6, null);
        operandPanel.add(jLabel1, null);
        operandPanel.add(op1Lbl, null);
        operandPanel.add(op2Lbl, null);
        operandPanel.add(op3Lbl, null);
        operandPanel.add(op4Lbl, null);
        operandPanel.add(op5Lbl, null);
        operandPanel.add(op6Lbl, null);
        operandPanel.add(answerBtn, null);
        operandPanel.add(answerLbl, null);
    }

    //Overriden so we can exit on System Close
    protected void processWindowEvent(WindowEvent e) {
        super.processWindowEvent(e);
        if (e.getID() == WindowEvent.WINDOW_CLOSING) {
            System.exit(0);
        }
    }

    void op6_actionPerformed(ActionEvent e) {

    }

    void this_windowOpened(WindowEvent e) {
        postfixPanel.setVisible(false);
        operandPanel.setVisible(false);
    }

    void infixField_keyPressed(KeyEvent e) {
        if (e.getKeyCode() == KeyEvent.VK_ENTER) {
            if (infixField.getText().trim().length() > 0) {
                postfixPanel.setVisible(true);
                operandPanel.setVisible(true);
                op1Lbl.setVisible(false);
                op2Lbl.setVisible(false);
                op3Lbl.setVisible(false);
                op4Lbl.setVisible(false);
                op5Lbl.setVisible(false);
                op6Lbl.setVisible(false);
                op1.setVisible(false);
                op2.setVisible(false);
                op3.setVisible(false);
                op4.setVisible(false);
                op5.setVisible(false);
                op6.setVisible(false);
                f = new FunctionEvaluation(infixField.getText().trim());
                f.infixToPostfix();
                // Load up dictionary with operand symbols
                String postfix = f.postfix();
                postfixField.setText(postfix);
                dictionary.makeEmpty();
                numOperands = 0;
                for (int index = 0; index < postfix.length(); index++) {
                    char ch = postfix.charAt(index);
                    if (ch >= 'a' && ch <= 'z') // alphabetic character
                        if (!dictionary.containsKey(new Character(ch))) {
                            numOperands++;
                            switch (numOperands) {
                                case 1:
                                    dictionary.addKey(new Character(ch), new Double(Double.MIN_VALUE));
                                    op1Lbl.setText("Operand " + ch);
                                    op1Lbl.setVisible(true);
                                    op1.setVisible(true);
                                    break;
                                case 2:
                                    dictionary.addKey(new Character(ch), new Double(Double.MIN_VALUE));
                                    op2Lbl.setText("Operand " + ch);
                                    op2Lbl.setVisible(true);
                                    op2.setVisible(true);
                                    break;
                                case 3:
                                    dictionary.addKey(new Character(ch), new Double(Double.MIN_VALUE));
                                    op3Lbl.setText("Operand " + ch);
                                    op3Lbl.setVisible(true);
                                    op3.setVisible(true);
                                    break;
                                case 4:
                                    dictionary.addKey(new Character(ch), new Double(Double.MIN_VALUE));
                                    op4Lbl.setText("Operand " + ch);
                                    op4Lbl.setVisible(true);
                                    op4.setVisible(true);
                                    break;
                                case 5:
                                    dictionary.addKey(new Character(ch), new Double(Double.MIN_VALUE));
                                    op5Lbl.setText("Operand " + ch);
                                    op5Lbl.setVisible(true);
                                    op5.setVisible(true);
                                    break;
                                case 6:
                                    dictionary.addKey(new Character(ch), new Double(Double.MIN_VALUE));
                                    op6Lbl.setText("Operand " + ch);
                                    op6Lbl.setVisible(true);
                                    op6.setVisible(true);
                                    break;
                                default:
                                    JOptionPane.showMessageDialog(this, "Only  six distinct variables are allowed.");
                            }
                        }
                }
            }
        }
    }

    void answerBtn_actionPerformed(ActionEvent e) {
        Iterator keys = dictionary.keys();
        char ch;
        double value;
        int index = 0;
        while (keys.hasNext()) {
            ch = ((Character) keys.next()).charValue();
            index++;
            try {
                switch (index) {
                    case 1:
                        value = (new Double(op1.getText().trim())).doubleValue();
                        f.setKeyValue(ch, value);
                        break;
                    case 2:
                        value = (new Double(op2.getText().trim())).doubleValue();
                        f.setKeyValue(ch, value);
                        break;
                    case 3:
                        value = (new Double(op3.getText().trim())).doubleValue();
                        f.setKeyValue(ch, value);
                        break;
                    case 4:
                        value = (new Double(op4.getText().trim())).doubleValue();
                        f.setKeyValue(ch, value);
                        break;
                    case 5:
                        value = (new Double(op5.getText().trim())).doubleValue();
                        f.setKeyValue(ch, value);
                        break;
                    case 6:
                        value = (new Double(op6.getText().trim())).doubleValue();
                        f.setKeyValue(ch, value);
                        break;
                }
            }
            catch (Exception ex) {
                JOptionPane.showMessageDialog(this, "Blank input or illegal input for operand value.");
            }
        }
        DecimalFormat df = new DecimalFormat("0.####");
        if (f.evaluate() == Double.MAX_VALUE)
            answerLbl.setText("Answer: Infinity");
        else
            answerLbl.setText("Answer: " + df.format(f.evaluate()));
    }
}
