/** A test class for ExpressionBinaryTree (prefix input)
*/
import foundations.*;
import java.io.*;

public class ExpressionTest{

	public static void main(String[] args) throws IOException {
		ExpressionBinaryTreeE expr = new ExpressionBinaryTreeE("a+b/(c-d)-e");
		if (!expr.isEmpty()){
			System.out.println("The number of terms in the tree is: " + expr.size());
			System.out.println("Equiv infix string is:   " + expr.traverseInorder());
			System.out.println("Equiv prefix string is:  " + expr.traversePreorder());
			System.out.println("Equiv postfix string is: " + expr.traversePostorder());
		}
		System.out.println("Test makeEmpty()");
		expr.makeEmpty();
		System.out.println("The number of terms in the tree is: " + expr.size() + "\n");
		expr.setInfixString("a*b/(c-d)*e");//"a*b-(c-d*e)+f/(g-h)" or "a+b-(c-d*e)"
		if (!expr.isEmpty()){
			System.out.println("The number of terms in the tree is: " + expr.size());
			System.out.println("Equiv infix string is:   " + expr.traverseInorder());
			System.out.println("Equiv prefix string is:  " + expr.traversePreorder());
			System.out.println("Equiv postfix string is: " + expr.traversePostorder());
		}
		System.out.println("Test makeEmpty()");
		expr.makeEmpty();
		System.out.println("The number of terms in the tree is: " + expr.size() + "\n");
		expr.setInfixString("a+(b-c)-d/e");//"a*b-(c-d*e)+f/(g-h)" or "a+b-(c-d*e)"
		if (!expr.isEmpty()){
			System.out.println("The number of terms in the tree is: " + expr.size());
			System.out.println("Equiv infix string is:   " + expr.traverseInorder());
			System.out.println("Equiv prefix string is:  " + expr.traversePreorder());
			System.out.println("Equiv postfix string is: " + expr.traversePostorder());
		}
		System.out.println("Test makeEmpty()");
		expr.makeEmpty();
		System.out.println("The number of terms in the tree is: " + expr.size() + "\n");
		expr.setInfixString("a*b-(c-d*e)+f/(g-h)");//"a*b-(c-d*e)+f/(g-h)" or "a+b-(c-d*e)"
		if (!expr.isEmpty()){
			System.out.println("The number of terms in the tree is: " + expr.size());
			System.out.println("Equiv infix string is:   " + expr.traverseInorder());
			System.out.println("Equiv prefix string is:  " + expr.traversePreorder());
			System.out.println("Equiv postfix string is: " + expr.traversePostorder());
		}
		System.out.println("Test makeEmpty()");
		expr.makeEmpty();
		System.out.println("The number of terms in the tree is: " + expr.size() + "\n");

		BufferedReader keyboard = new BufferedReader(new InputStreamReader(System.in));
		String postfix = "";

		do {
			System.out.print("Enter a postfix string: ");
			postfix = keyboard.readLine();
			expr.setPostfixString(postfix);
			if (!expr.isEmpty()){
				System.out.println("The number of terms in the tree is: " + expr.size());
				System.out.println("Equiv infix string is:   " + expr.traverseInorder());
				System.out.println("Equiv prefix string is:  " + expr.traversePreorder());
				System.out.println("Equiv postfix string is: " + expr.traversePostorder());
			}
			System.out.println("Test makeEmpty()");
			expr.makeEmpty();
			System.out.println("The number of terms in the tree is: " + expr.size() + "\n");	
		} while (postfix.length() >= 3);
		
	}
}
