/** A test class for PrefixExpressionTree (prefix input)
*/
import foundations.*;
import java.io.*;

public class ExpressionTestPre{

	public static void main(String[] args) throws IOException {
		PrefixExpressionTree expr = new PrefixExpressionTree("+a-/b-cde");
		if (!expr.isEmpty()){
			System.out.println("The number of terms in the tree is: " + expr.size());
			System.out.println("Equiv infix string is:   " + expr.traverseInorder());
			System.out.println("Equiv prefix string is:  " + expr.traversePreorder());
			System.out.println("Equiv postfix string is: " + expr.traversePostorder());
		}
		System.out.println("Test makeEmpty()");
		expr.makeEmpty();
		System.out.println("The number of terms in the tree is: " + expr.size() + "\n");
		expr.setPrefixString("*/*ab-cde");
		if (!expr.isEmpty()){
			System.out.println("The number of terms in the tree is: " + expr.size());
			System.out.println("Equiv infix string is:   " + expr.traverseInorder());
			System.out.println("Equiv prefix string is:  " + expr.traversePreorder());
			System.out.println("Equiv postfix string is: " + expr.traversePostorder());
		}
		System.out.println("Test makeEmpty()");
		expr.makeEmpty();
		System.out.println("The number of terms in the tree is: " + expr.size() + "\n");
		expr.setPrefixString("-+a-bc/de");
		if (!expr.isEmpty()){
			System.out.println("The number of terms in the tree is: " + expr.size());
			System.out.println("Equiv infix string is:   " + expr.traverseInorder());
			System.out.println("Equiv prefix string is:  " + expr.traversePreorder());
			System.out.println("Equiv postfix string is: " + expr.traversePostorder());
		}
		System.out.println("Test makeEmpty()");
		expr.makeEmpty();
		System.out.println("The number of terms in the tree is: " + expr.size() + "\n");
		expr.setPrefixString("+-*ab-c*de/f-gh");
		if (!expr.isEmpty()){
			System.out.println("The number of terms in the tree is: " + expr.size());
			System.out.println("Equiv infix string is:   " + expr.traverseInorder());
			System.out.println("Equiv prefix string is:  " + expr.traversePreorder());
			System.out.println("Equiv postfix string is: " + expr.traversePostorder());
		}
		System.out.println("Test makeEmpty()");
		expr.makeEmpty();
		System.out.println("The number of terms in the tree is: " + expr.size() + "\n");

		BufferedReader keyboard = new BufferedReader(new InputStreamReader(System.in));
		String prefix = "";

		do {
			System.out.print("Enter a prefix string (cr to quit): ");
			prefix = keyboard.readLine();
			expr.setPrefixString(prefix);
			if (!expr.isEmpty()){
				System.out.println("The number of terms in the tree is: " + expr.size());
				System.out.println("Equiv infix string is:   " + expr.traverseInorder());
				System.out.println("Equiv prefix string is:  " + expr.traversePreorder());
				System.out.println("Equiv postfix string is: " + expr.traversePostorder());
			}
			System.out.println("Test makeEmpty()");
			expr.makeEmpty();
			System.out.println("The number of terms in the tree is: " + expr.size() + "\n");	
		} while (prefix.length() >= 3);
		
	}
}
