import foundations.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.*;
//import com.sun.java.swing.*;

public class HeapAppUI extends JFrame {

    // Model
    
    Heap theHeap;

	// Components
	
    JPanel actionPanel = new JPanel();
    JScrollPane scrollPane = new JScrollPane();
    JLabel labelMessages = new JLabel();
    JLabel labelAction = new JLabel();
    JTextArea textArea = new JTextArea();
    JButton buttonConstruct = new JButton();
    JLabel labelCommands = new JLabel();
    JLabel labelQueries = new JLabel();
    JTextField tfAdd = new JTextField();
    JComboBox heapSelect = new JComboBox();
    JButton buttonAdd = new JButton();
    JButton buttonRemove = new JButton();
    JButton buttonSort = new JButton();
    JButton buttonMakeEmpty = new JButton();
    JButton buttonTop = new JButton();
    JButton buttonIsEmpty = new JButton();
    JButton buttonSize = new JButton();
    JButton buttonIterator = new JButton();

    //Construct the frame

    public HeapAppUI() {
        enableEvents(AWTEvent.WINDOW_EVENT_MASK);
        try  {
            jbInit();
        }
        catch (Exception e) {
            e.printStackTrace();
        }
    }
    
	//Component initialization
    
    private void jbInit() throws Exception  {
        this.getContentPane().setLayout(null);
        this.setSize(new Dimension(554, 402));
        actionPanel.setBackground(new Color(255, 255, 200));
        actionPanel.setLayout(null);
        actionPanel.setBounds(new Rectangle(10, 43, 258, 326));
        scrollPane.setBackground(Color.white);
        scrollPane.setBounds(new Rectangle(280, 43, 258, 326));
        labelMessages.setText("Messages");
        labelMessages.setBounds(new Rectangle(378, 15, 62, 15));
        labelAction.setText("Actions");
        labelAction.setBounds(new Rectangle(116, 15, 46, 15));
        buttonConstruct.setText("Construct");
        buttonConstruct.setBounds(new Rectangle(79, 49, 101, 23));
        buttonConstruct.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                buttonConstruct_actionPerformed(e);
            }
        });
        labelCommands.setText("Commands");
        labelCommands.setBounds(new Rectangle(17, 88, 101, 18));
        labelCommands.setHorizontalAlignment(SwingConstants.CENTER);
        labelQueries.setText("Queries");
        labelQueries.setBounds(new Rectangle(138, 88, 101, 18));
        labelQueries.setHorizontalAlignment(SwingConstants.CENTER);
        buttonAdd.setText("Add");
        buttonAdd.setBounds(new Rectangle(9, 115, 114, 23));
        buttonAdd.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                buttonAdd_actionPerformed(e);
            }
        });
        buttonRemove.setText("RemoveTop");
        buttonRemove.setBounds(new Rectangle(9, 188, 114, 23));
        buttonRemove.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                buttonRemove_actionPerformed(e);
            }
        });
        buttonSort.setText("Sort");
        buttonSort.setBounds(new Rectangle(9, 237, 114, 23));
        buttonSort.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                buttonSort_actionPerformed(e);
            }
        });
        buttonMakeEmpty.setText("MakeEmpty");
        buttonMakeEmpty.setBounds(new Rectangle(9, 287, 114, 23));
        buttonMakeEmpty.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                buttonMakeEmpty_actionPerformed(e);
            }
        });
        buttonTop.setText("Top");
        buttonTop.setBounds(new Rectangle(137, 138, 114, 23));
        buttonTop.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                buttonTop_actionPerformed(e);
            }
        });
        buttonIsEmpty.setText("IsEmpty");
        buttonIsEmpty.setBounds(new Rectangle(137, 188, 114, 23));
        buttonIsEmpty.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                buttonIsEmpty_actionPerformed(e);
            }
        });
        buttonSize.setText("Size");
        buttonSize.setBounds(new Rectangle(137, 237, 114, 23));
        buttonSize.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                buttonSize_actionPerformed(e);
            }
        });
        buttonIterator.setText("Traverse");
        buttonIterator.setBounds(new Rectangle(137, 287, 114, 23));
        buttonIterator.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                buttonIterator_actionPerformed(e);
            }
        });

        tfAdd.setText("string");
        tfAdd.setBounds(new Rectangle(9, 148, 67, 21));
        heapSelect.setBounds(new Rectangle(17, 13, 222, 25));
        heapSelect.addItem("BinaryTreeHeap");
        heapSelect.addItem("BinaryTreeHeapE");
        heapSelect.addItem("VectorHeap");
        heapSelect.addItem("VectorHeapE");
        heapSelect.addItem("HeapE");
        heapSelect.setSelectedItem(heapSelect.getItemAt(0));
        this.setTitle("Heap Laboratory");
        this.getContentPane().add(actionPanel, null);
        actionPanel.add(buttonConstruct, null);
        actionPanel.add(labelCommands, null);
        actionPanel.add(labelQueries, null);
        actionPanel.add(tfAdd, null);
        actionPanel.add(heapSelect, null);
        actionPanel.add(buttonMakeEmpty, null);
        actionPanel.add(buttonSort, null);
        actionPanel.add(buttonRemove, null);
        actionPanel.add(buttonIterator, null);
        actionPanel.add(buttonSize, null);
        actionPanel.add(buttonIsEmpty, null);
        actionPanel.add(buttonTop, null);
        actionPanel.add(buttonAdd, null);
        this.getContentPane().add(scrollPane, null);
        scrollPane.getViewport().add(textArea, null);
        this.getContentPane().add(labelAction, null);
        this.getContentPane().add(labelMessages, null);
        enableWidgets(false);
    }

	//Overriden so we can exit on System Close
    
    protected void processWindowEvent(WindowEvent e) {
        super.processWindowEvent(e);
        if (e.getID() == WindowEvent.WINDOW_CLOSING) {
            System.exit(0);
        }
    }

    void enableWidgets(boolean b){
        labelCommands.setVisible(b);
        labelQueries.setVisible(b);
        buttonAdd.setVisible(b);
        tfAdd.setVisible(b);
        buttonRemove.setVisible(b);
        buttonSort.setVisible(b);
        buttonMakeEmpty.setVisible(b);
        buttonTop.setVisible(b);
        buttonIsEmpty.setVisible(b);
        buttonSize.setVisible(b);
        buttonIterator.setVisible(b);
    }


    void buttonConstruct_actionPerformed(ActionEvent e) {
    	textArea.setText("");
        int i = heapSelect.getSelectedIndex();
        if (i == 0){
            theHeap = new BinaryTreeHeap();
            textArea.append("BinaryTreeHeap created\n");
        }
        else if (i == 1){
            theHeap = new BinaryTreeHeapE();
            textArea.append("BinaryTreeHeapE created\n");
        }
        else if (i == 2){
            theHeap = new VectorHeap();
            textArea.append("VectorHeap created\n");
        }
        else if (i == 3){
            theHeap = new VectorHeapE();
            textArea.append("VectorHeapE created\n");
        }
        else if (i == 4){
            theHeap = new HeapE();
            textArea.append("HeapE created\n");
        }
        enableWidgets(true);
        tfAdd.requestFocus();
    }

    void buttonAdd_actionPerformed(ActionEvent e) {
        theHeap.add(tfAdd.getText());
        textArea.append(tfAdd.getText() + " - added to the heap\n");
    }

    void buttonRemove_actionPerformed(ActionEvent e) {
    	try{
        	theHeap.removeTop();
        	textArea.append("Top removed\n");
        } catch(Exception ex) {
        	textArea.append("Heap is empty\n");
        }
    }

    void buttonSort_actionPerformed(ActionEvent e) {
	     theHeap.sort();
    	 textArea.append("Heap elements are sorted\n");
    }

    void buttonMakeEmpty_actionPerformed(ActionEvent e) {
   	    theHeap.makeEmpty();
       	textArea.append("Heap is now empty\n");
        	
    }

    void buttonTop_actionPerformed(ActionEvent e) {
        try{
            textArea.append("Top of the heap: " + theHeap.top() + "\n");
        } catch (Exception ex) {
            textArea.append(ex.getMessage() + "\n");
        }
    }

    void buttonIsEmpty_actionPerformed(ActionEvent e) {
        textArea.append("Heap is " + ((theHeap.isEmpty()) ? "" : "not") + " empty\n");
    }

    void buttonSize_actionPerformed(ActionEvent e) {
         textArea.append("Heap size: " + theHeap.size() + "\n");
    }

    void buttonIterator_actionPerformed(ActionEvent e) {
    	 if (!theHeap.isEmpty()){
         	String str = "";
         	for (Iterator iter = theHeap.traverseLevels(); iter.hasNext();)
            	str = str + iter.next() + "->";
         	textArea.append(str.substring(0, str.length() -2) + "\n");
         }
         else
         	textArea.append("Heap is empty\n");
    }
}
