/** A simple test class for VectorHeap implementation
*/
import foundations.*;
import java.util.*;

public class TreeHeapTest{

	public static void main(String[] args){

		Integer [] integers = new Integer[10];
		Random rand = new Random();
		int i;

		// Test constructor VectorHeap(Object[]), buildHeap(), swap() and traversal
		System.out.println("Create array of random ints");
		for (i = 0; i < 10; i++)
			integers[i] = new Integer(rand.nextInt(501));
		for (i = 0; i < 10; i++)
			System.out.println("integers[" + i + "] = " + integers[i]);

		System.out.println("\nCreate heap from the array");
		Heap heap = new BinaryTreeHeap(integers);
		System.out.println("Size of heap is now: " + heap.size() + " isEmpty() returns: " + heap.isEmpty());
		System.out.println("Top element on heap is: " + heap.top());

		System.out.println("Level Traversal of heap");
		i = 0;
		for (Iterator iter = heap.traverseLevels(); iter.hasNext(); i++ )
			System.out.println("Heap node [" + i + "] = " + iter.next());

		System.out.println("makeEmpty");
		heap.makeEmpty();
		System.out.println("Size of heap is now: " + heap.size() + " isEmpty() returns: " + heap.isEmpty());
		System.out.println("Level Traversal of heap");
		i = 0;
		for (Iterator iter = heap.traverseLevels(); iter.hasNext(); i++ )
			System.out.println("Heap node [" + i + "] = " + iter.next());


		// Test add(), removeTop(), size(), makeEmpty(), isEmpty(), top(), restoreHeap()
		System.out.println("\nCreate a heap one Integer at a time");
		heap = new BinaryTreeHeap();
		for (i = 0; i < 10; i++){
			int val = rand.nextInt(501);
			System.out.println("Try to add " + val);
			heap.add(new Integer(val));
			
		}
		System.out.println("Size of new heap is: " + heap.size());
		System.out.println("Top element on heap is: " + heap.top());
		System.out.println("Level Traversal of heap");
		i = 0;
		for (Iterator iter = heap.traverseLevels(); iter.hasNext(); i++ )
			System.out.println("Heap node [" + i + "] = " + iter.next());
		System.out.println("Remove top");
		heap.removeTop();
		System.out.println("Size of heap is now: " + heap.size());
		System.out.println("Top element on heap is: " + heap.top());
		System.out.println("Level Traversal of heap");
		i = 0;
		for (Iterator iter = heap.traverseLevels(); iter.hasNext(); i++ )
			System.out.println("Heap node [" + i + "] = " + iter.next());		

		System.out.println("\nSort the heap and traverse levels");
		heap.sort();
		i = 0;
		for (Iterator iter = heap.traverseLevels(); iter.hasNext(); i++ )
			System.out.println("Heap node [" + i + "] = " + iter.next());		

	}
}
