import foundations.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.*;
//import com.sun.java.swing.*;

public class PQAppUI extends JFrame {

    // Model
    
    PriorityQueue pq;
    boolean intKey;		// QueuesPriorityQueue sets true

	// Components
	
    JPanel actionPanel = new JPanel();
    JScrollPane scrollPane = new JScrollPane();
    JLabel labelMessages = new JLabel();
    JLabel labelAction = new JLabel();
    JTextArea textArea = new JTextArea();
    JButton buttonConstruct = new JButton();
    JLabel labelCommands = new JLabel();
    JLabel labelQueries = new JLabel();
    JTextField tfKey = new JTextField();
    JComboBox pqSelect = new JComboBox();
    JButton buttonAdd = new JButton();
    JButton buttonRemove = new JButton();
    JButton buttonMakeEmpty = new JButton();
    JButton buttonHighest = new JButton();
    JButton buttonContains = new JButton();
    JButton buttonGet = new JButton();
    JButton buttonIsEmpty = new JButton();
    JTextField tfValue = new JTextField();
    JLabel labelKey = new JLabel();
    JLabel labelValue = new JLabel();
    JButton buttonSize = new JButton();
    JButton buttonElements = new JButton();
    JButton buttonPriorities = new JButton();
    JButton buttonAddAssoc = new JButton();

    //Construct the frame

    public PQAppUI() {
        enableEvents(AWTEvent.WINDOW_EVENT_MASK);
        try  {
            jbInit();
        }
        catch (Exception e) {
            e.printStackTrace();
        }
    }
    
	//Component initialization
    
    private void jbInit() throws Exception  {
        this.getContentPane().setLayout(null);
        this.setSize(new Dimension(568, 406));
        actionPanel.setBackground(new Color(255, 255, 200));
        actionPanel.setLayout(null);
        actionPanel.setBounds(new Rectangle(8, 43, 276, 328));
        scrollPane.setBackground(Color.white);
        scrollPane.setBounds(new Rectangle(295, 43, 258, 328));
        labelMessages.setText("Messages");
        labelMessages.setBounds(new Rectangle(378, 15, 62, 15));
        labelMessages.setHorizontalAlignment(SwingConstants.CENTER);
        labelAction.setText("Actions");
        labelAction.setBounds(new Rectangle(123, 15, 46, 15));
        labelAction.setHorizontalAlignment(SwingConstants.CENTER);
        buttonConstruct.setText("Construct");
        buttonConstruct.setBounds(new Rectangle(88, 42, 101, 23));
        buttonConstruct.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                buttonConstruct_actionPerformed(e);
            }
        });
        labelCommands.setText("Commands");
        labelCommands.setBounds(new Rectangle(9, 76, 124, 18));
        labelCommands.setHorizontalAlignment(SwingConstants.CENTER);
        labelQueries.setText("Queries");
        labelQueries.setBounds(new Rectangle(145, 76, 124, 18));
        labelQueries.setHorizontalAlignment(SwingConstants.CENTER);
        buttonAdd.setText("Add(key)");
        buttonAdd.setBounds(new Rectangle(9, 105, 124, 23));
        buttonAdd.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                buttonAdd_actionPerformed(e);
            }
        });
        buttonRemove.setText("RemoveHigh");
        buttonRemove.setBounds(new Rectangle(9, 249, 124, 23));
        buttonRemove.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                buttonRemove_actionPerformed(e);
            }
        });
        buttonMakeEmpty.setText("MakeEmpty");
        buttonMakeEmpty.setBounds(new Rectangle(9, 297, 124, 23));
        buttonMakeEmpty.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                buttonMakeEmpty_actionPerformed(e);
            }
        });
        buttonHighest.setText("Highest");
        buttonHighest.setBounds(new Rectangle(145, 105, 124, 23));
        buttonHighest.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                buttonHighest_actionPerformed(e);
            }
        });
        tfValue.setBounds(new Rectangle(51, 170, 82, 21));
        labelKey.setText("Key");
        labelKey.setBounds(new Rectangle(9, 140, 40, 16));
        labelKey.setHorizontalAlignment(SwingConstants.LEFT);
        labelValue.setText("Value");
        labelValue.setBounds(new Rectangle(9, 172, 40, 16));
        labelValue.setHorizontalAlignment(SwingConstants.LEFT);
        buttonSize.setText("Size");
        buttonSize.setBounds(new Rectangle(145, 233, 124, 23));
        buttonSize.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                buttonSize_actionPerformed(e);
            }
        });
        buttonElements.setText("Elements");
        buttonElements.setBounds(new Rectangle(145, 265, 124, 23));
        buttonElements.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                buttonElements_actionPerformed(e);
            }
        });
        buttonPriorities.setText("Keys-priorities");
        buttonPriorities.setBounds(new Rectangle(145, 297, 124, 23));
        buttonPriorities.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                buttonPriorities_actionPerformed(e);
            }
        });
        buttonAddAssoc.setText("Add(key,value)");
        buttonAddAssoc.setBounds(new Rectangle(9, 201, 124, 23));
        buttonAddAssoc.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                buttonAddAssoc_actionPerformed(e);
            }
        });
        buttonContains.setText("Contains(key)");
        buttonContains.setBounds(new Rectangle(145, 137, 124, 23));
        buttonContains.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                buttonContains_actionPerformed(e);
            }
        });
        buttonGet.setText("Get(key)");
        buttonGet.setBounds(new Rectangle(145, 169, 124, 23));
        buttonGet.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                buttonGet_actionPerformed(e);
            }
        });
        buttonIsEmpty.setText("IsEmpty");
        buttonIsEmpty.setBounds(new Rectangle(145, 201, 124, 23));
        buttonIsEmpty.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                buttonIsEmpty_actionPerformed(e);
            }
        });
        tfKey.setText("Comparable");
        tfKey.setBounds(new Rectangle(51, 138, 82, 21));
        pqSelect.setBounds(new Rectangle(27, 9, 222, 25));
        pqSelect.addItem("HeapPriorityQueue");
        pqSelect.addItem("HeapPriorityQueueE");
        pqSelect.addItem("QueuesPriorityQueue");
        pqSelect.addItem("QueuesPriorityQueueE");
        pqSelect.addItem("PriorityQueueE");
        pqSelect.setSelectedItem(pqSelect.getItemAt(0));
        this.setTitle("PriorityQueue Laboratory");
        this.getContentPane().add(actionPanel, null);
        actionPanel.add(buttonConstruct, null);
        actionPanel.add(labelCommands, null);
        actionPanel.add(labelQueries, null);
        actionPanel.add(pqSelect, null);
        actionPanel.add(buttonMakeEmpty, null);
        actionPanel.add(buttonAddAssoc, null);
        actionPanel.add(buttonRemove, null);
        actionPanel.add(buttonPriorities, null);
        actionPanel.add(buttonElements, null);
        actionPanel.add(buttonSize, null);
        actionPanel.add(buttonIsEmpty, null);
        actionPanel.add(buttonGet, null);
        actionPanel.add(buttonContains, null);
        actionPanel.add(buttonHighest, null);
        actionPanel.add(buttonAdd, null);
        actionPanel.add(labelKey, null);
        actionPanel.add(tfValue, null);
        actionPanel.add(labelValue, null);
        actionPanel.add(tfKey, null);
        this.getContentPane().add(scrollPane, null);
        scrollPane.getViewport().add(textArea, null);
        this.getContentPane().add(labelAction, null);
        this.getContentPane().add(labelMessages, null);
        enableWidgets(false);
    }

	//Overriden so we can exit on System Close
    
    protected void processWindowEvent(WindowEvent e) {
        super.processWindowEvent(e);
        if (e.getID() == WindowEvent.WINDOW_CLOSING) {
            System.exit(0);
        }
    }

    void enableWidgets(boolean b){
        labelCommands.setVisible(b);
        labelQueries.setVisible(b);
        buttonAdd.setVisible(b);
        buttonAddAssoc.setVisible(b);
        labelKey.setVisible(b);
        labelValue.setVisible(b);
        tfKey.setVisible(b);
        tfValue.setVisible(b);
        buttonRemove.setVisible(b);
        buttonMakeEmpty.setVisible(b);
        buttonHighest.setVisible(b);
        buttonContains.setVisible(b);
        buttonGet.setVisible(b);
        buttonIsEmpty.setVisible(b);
        buttonSize.setVisible(b);
        buttonElements.setVisible(b);
        buttonPriorities.setVisible(b);
    }


	boolean validateInteger(String comp){
    	try{
			Integer i = new Integer(comp);
			if (i.intValue() < 0 || i.intValue() > 9){
				textArea.append("Key out of range (0--9)	\n");
				return false;
			}
			return true;
		}
		catch (Exception ex) {
			textArea.append("Key must be an integer\n");
			return false;
		}
	}


    void buttonConstruct_actionPerformed(ActionEvent e) {
    	textArea.setText("");
        int i = pqSelect.getSelectedIndex();
        if (i == 0){
            pq = new HeapPriorityQueue();
            tfKey.setText("String");
            intKey = false;
            tfValue.setText("String");
            textArea.append("HeapPriorityQueue created\n");
        }
        else if (i == 1){
            pq = new HeapPriorityQueueE();
            tfKey.setText("String");
            intKey = false;
            tfValue.setText("String");
            textArea.append("HeapPriorityQueueE created\n");
        }
        else if (i == 2){
            pq = new QueuesPriorityQueue(10);
            textArea.append("New QueuesPQ (maxPriority = 9)\n");
            tfKey.setText("Integer");
            intKey = true;
            tfValue.setText("String");
        }
        else if (i == 3){
            pq = new QueuesPriorityQueueE(10);
            textArea.append("New QueuesPQE (maxPriority = 9)\n");
            tfKey.setText("Integer");
            intKey = true;
            tfValue.setText("String");
        }
        else if (i == 4){
            pq = new PriorityQueueE();
            tfKey.setText("String");
            intKey = false;
            tfValue.setText("String");
            textArea.append("PriorityQueueE created\n");
        }
        enableWidgets(true);
        tfKey.requestFocus();
    }

    void buttonAdd_actionPerformed(ActionEvent e) {
		// Adding Comparable items (strings) to PQ - no Associations
		buttonAddAssoc.setVisible(false);
		tfValue.setVisible(false);
		labelValue.setVisible(false);
		Comparable comp = tfKey.getText();
		if (intKey)
			if (validateInteger((String)comp))
				comp = new Integer((String)comp);
			else
				return;
		pq.add(comp);
		textArea.append("Added to PQ: " + comp + "\n");
    }

    void buttonAddAssoc_actionPerformed(ActionEvent e) {
		// Adding Associations to PQ
		buttonAdd.setVisible(false);
		Comparable comp = tfKey.getText();
		if (intKey)
			if (validateInteger((String)comp))
				comp = new Integer((String)comp);
			else
				return;
		Association asc = new Association(comp, tfValue.getText());
		pq.add(asc);
		textArea.append("Added to PQ: " + asc + "\n");
    }

    void buttonRemove_actionPerformed(ActionEvent e) {
    	// PriorityQueue always removes top - use null parameter
		if (pq.isEmpty())
			textArea.append("PQ is empty\n");
		else {
			pq.remove(null);
			textArea.append("Removed top priority item\n");
		}
    }

    void buttonMakeEmpty_actionPerformed(ActionEvent e) {
		pq.makeEmpty();
		textArea.append("PQ is made empty\n");
    }

    void buttonHighest_actionPerformed(ActionEvent e) {
		if (pq.isEmpty())
			textArea.append("PQ is empty\n");
		else 
			textArea.append("Top priority item: " + pq.highest() + "\n");
    }

    void buttonContains_actionPerformed(ActionEvent e) {
		if (pq.isEmpty())
			textArea.append("PQ is empty\n");
		else {
			Comparable comp = tfKey.getText();
			if (intKey)
				if (!validateInteger((String)comp))
					return;
				else
					comp = new Integer((String)comp);
			if (buttonAdd.isVisible()) // keys only
				textArea.append("Key: " + comp + " is " +
							((pq.contains(comp))
								? ""
								: "not ") + "found\n");
			else  // Associations
				textArea.append("Key: " + comp + " is " +
							((pq.contains(new Association(comp, null)))
								? ""
								: "not ") + "found\n");
		}
    }

    void buttonGet_actionPerformed(ActionEvent e) {
		if (pq.isEmpty())
			textArea.append("PQ is empty\n");
		else {
			Comparable comp = tfKey.getText();
			if (intKey)
				if (!validateInteger((String)comp))
					return;
				else
					comp = new Integer((String)comp);
			if (buttonAdd.isVisible()) // keys only
				comp = pq.get(comp);
			else  // Associations
				comp = pq.get(new Association(comp, null));
			textArea.append("Item for key: " 
								+ ((comp==null)
									? "not found"
									: comp) + "\n");
		}
    }

    void buttonIsEmpty_actionPerformed(ActionEvent e) {
		textArea.append("PQ is " + ((pq.isEmpty()) ? "" : "not ") + "empty\n");
    }

    void buttonSize_actionPerformed(ActionEvent e) {
		textArea.append("PQ has size: " + pq.size() + "\n");
    }

    void buttonElements_actionPerformed(ActionEvent e) {
		if (pq.isEmpty())
			textArea.append("PQ is empty\n");
		else{
			int i = 0;
			textArea.append("Prioritized contents of PQ:\n");
			for (Iterator iter = pq.elements(); iter.hasNext(); i++)
				textArea.append("  Item " + i + ": " + iter.next() + "\n");
		}
    }

    void buttonPriorities_actionPerformed(ActionEvent e) {
		if (pq.isEmpty())
			textArea.append("PQ is empty\n");
		else{
			int i = 0;
			textArea.append("Prioritized keys of PQ:\n");
			for (Iterator iter = pq.priorities(); iter.hasNext(); i++)
				textArea.append("  Priority " + i + ": " + iter.next() + "\n");
		}
    }


}
