/** Class HeapPQtest - a test class for HeapPriorityQueue
*/
import foundations.*;
import java.util.*;

public class HeapPQtest{

	public static void main(String[] args){
		HeapPriorityQueue hpq = new HeapPriorityQueue();
		Random rand = new Random();
		int i, j;

		for (i = 0; i < 5; i++){
			j = rand.nextInt(101);
			hpq.add(new Integer(j));
			System.out.println("Added " + j + " to the PQ");
		}
		System.out.println("\nPriorityQueue completed, size = " + hpq.size() 
								+ ", highest priority = " + hpq.highest());
		System.out.println("Elements traversal ---");
		for (Iterator iter = hpq.elements(); iter.hasNext();)
			System.out.println(iter.next());

		hpq = new HeapPriorityQueue();
		String str;
		Association asc;
		// Rebuild using associations
		for (i = 0; i < 5; i++){
			j = rand.nextInt(101);
			str = "string" + j;
			asc = new Association(new Integer(j), str);
			System.out.println("Add " + j + " to the PQ");
			hpq.add(asc);
		}
		System.out.println("\nPriorityQueue completed, size = " + hpq.size() 
					+ ", highest priority = " + ((Association)hpq.highest()).key());
		System.out.println("Elements traversal ---");
		for (Iterator iter = hpq.elements(); iter.hasNext();)
			System.out.println(iter.next());

		System.out.println("\n Priorities traversal ---");
		for (Iterator iter = hpq.priorities(); iter.hasNext();)
			System.out.println(iter.next());
		hpq.remove(null);
		System.out.println("\nPriorityQueue completed, size = " + hpq.size() 
					+ ", highest priority = " + ((Association)hpq.highest()).key());
		System.out.println("Elements traversal ---");
		for (Iterator iter = hpq.elements(); iter.hasNext();)
			System.out.println(iter.next());
	}
}
