/** Class QueuesPQtest - a test class for HeapPriorityQueue
*/
import foundations.*;
import java.util.*;

public class QueuesPQtest{

	public static void main(String[] args){
		QueuesPriorityQueue qpq = new QueuesPriorityQueue(5);
		Random rand = new Random();
		int i, j;

		for (i = 0; i < 5; i++){
			j = rand.nextInt(5);
			qpq.add(new Integer(j));
			System.out.println("Added " + j + " to the PQ");
		}
		System.out.println("\nPriorityQueue completed, size = " + qpq.size() 
								+ ", highest priority = " + qpq.highest());
		System.out.println("Elements traversal ---");
		for (Iterator iter = qpq.elements(); iter.hasNext();)
			System.out.println(iter.next());

		qpq = new QueuesPriorityQueue(5);
		String str;
		Association asc;
		// Rebuild using associations
		for (i = 0; i < 5; i++){
			j = rand.nextInt(5);
			str = "string" + j;
			asc = new Association(new Integer(j), str);
			System.out.println("Add " + j + " to the PQ");
			qpq.add(asc);
		}
		System.out.println("\nPriorityQueue completed, size = " + qpq.size() 
					+ ", highest priority = " + ((Association)qpq.highest()).key());
		System.out.println("Elements traversal ---");
		for (Iterator iter = qpq.elements(); iter.hasNext();)
			System.out.println(iter.next());

		System.out.println("\n Priorities traversal ---");
		for (Iterator iter = qpq.priorities(); iter.hasNext();)
			System.out.println(iter.next());
		qpq.remove(null);
		System.out.println("\nPriorityQueue completed, size = " + qpq.size() 
					+ ", highest priority = " + ((Association)qpq.highest()).key());
		System.out.println("Elements traversal ---");
		for (Iterator iter = qpq.elements(); iter.hasNext();)
			System.out.println(iter.next());
	}
}
