/** An application that determines the number of collisions among
*   109,580 distinct words using the hashCode() function of class   
*   String and tables of increasing size.
*/
import java.io.*;

public class CollisionExperiment {

    // Fields
    private final int NUMBER_WORDS = 109580;
    String [] table;

    public void computeCollisions () {
        int hashIndex = 0;
        try {
            System.out.println ("Size\t\t\tCollisions");
            for (int size = NUMBER_WORDS; size <= 10 * NUMBER_WORDS; 
                 size += NUMBER_WORDS) {
                 table = new String[size];
                 BufferedReader diskInput = new BufferedReader (
                                      new InputStreamReader (
                                      new FileInputStream (
                                      new File("distinct.txt"))));
			  // Insert each line of disk input file into hash table
                int collisions = 0;
                String line = diskInput.readLine();
                while (line != null && line.length() > 0) {
                    hashIndex = Math.abs(line.hashCode()) % size;
                    if (table[hashIndex] == null)
                        table[hashIndex] = line;
                    else
                        collisions++;
                    line = diskInput.readLine();
                }
                System.out.println (size + "\t\t\t" + collisions);
            }
        }
        catch (Exception ex) {}
    }

    static public void main (String[] args)  {
        CollisionExperiment app = new CollisionExperiment();
        app.computeCollisions();
    }
}

