/** Application to determine the speed of Hashtable.
*/
import java.io.*;
import java.util.*;
import java.text.*;

public class HashTest {

    // Internal fields
    private final int SIZE = 109580;
    private int count = 0;
    private long elapsedTime = 0L;
    private Hashtable hash;

    public void performTest() throws Exception {
        long elapsedTime = 0L;
        long startTime, endTime;
        DecimalFormat df = new DecimalFormat("0.##");
        BufferedReader diskInput;
        String line;
        hash = new Hashtable(250000);
        diskInput = new BufferedReader (new InputStreamReader (
                                        new FileInputStream (
                                        new File ("distinct.txt"))));
        // Insert each line of disk input file into hash table
        line = diskInput.readLine();
        while (line != null) {
        	hash.put(line, line);
            line = diskInput.readLine();
        }
        System.out.println ("hash.size() = " + hash.size());

        System.out.println ("Checking words against hash table");
        elapsedTime = 0;
        diskInput = new BufferedReader (new InputStreamReader (
                                        new FileInputStream (
                                        new File ("distinct.txt"))));
        line = diskInput.readLine();
        while (line != null) {
            startTime = System.currentTimeMillis();
            if (hash.containsKey(line))
                count++;
            endTime = System.currentTimeMillis();
            elapsedTime += endTime - startTime;
            line = diskInput.readLine();
        }
        System.out.println ("Words found in hash table = " + count);
        System.out.println ("Words checked per second = " +
                            (int) (count * 1000.0 / elapsedTime) +
                            " words per second.");
    }

    public static void main(String[] args) throws Exception {
        HashTest app = new HashTest();
        app.performTest();
    }
}

