/** A perfect hash function for words of five characters or less.
*/
import java.util.*;

public class PerfectHash {

    private BitSet data = new BitSet (14900787);

    private int convert (char ch) {
        if (ch >= 'a' && ch <= 'z')
            return ch - 'a' + 1;
        else if (ch == '\'')
            return 27;
        else
            return 0;
    }


    // Commands

    public void insert (String word) {
        if (word.trim().length() <= 5)
            data.set (hashIndex (word));
    }

    // Queries

    public int hashIndex (String word) {
        if (word.trim().length() <= 5) {
            String str = word.toLowerCase().trim();
            int sum = convert (str.charAt (0));
            int multiplier = 27;
            for (int index = 1; index < str.length(); index++) {
                sum += convert (str.charAt (index)) * multiplier;
                multiplier *= 27;
            }
            return sum;
        }
        else
            return -1;
    }

    public boolean contains (String word) {
        return data.get(hashIndex (word));
    }
}

