/** An application program that computes the prime numbers from 2 to
*   one million using bit sets and the Sieve of Eratosthenes algorithm.
*   Prime numbers are output to the console up to the value printTo.
*/
import java.util.*;

public class Primes {
    private final static int SIZE = 1000000;
    private final static int printTo = 5000;

    // Commands
    public void computePrimes () {
        BitSet b = new BitSet (SIZE);
        int count = 0;
        int i;

        // Set all the bits from 2 to 1,000,000
        for (i = 2; i < SIZE; i++)
            b.set (i);

	    // eliminate (turn off) multiples of prime numbers
        i = 2;	// start with smallest prime number
        while (i * i < SIZE) {
            if (b.get(i)) {
                count++;
                int k = 2 * i;
                while (k <= SIZE) {
                    b.clear (k);
                    k += i;
                }
            }
            i++;
        }
		
	   // display results
        for (i = 2, count = 0; i < SIZE; i++) 
            if (b.get (i)) {
                if (i <= printTo)
                    System.out.print (i + "  ");
                count++;
        	}
        System.out.println ("\nNumber of primes between 2 and " + SIZE +
                            " = " + count);
    }

    public static void main (String[] args) {
        Primes app = new Primes();
        app.computePrimes();
    }
}

