import java.awt.*;
import java.awt.event.*;
import foundations.*;
import javax.swing.*;         
import java.util.*;         

public class DictionaryLabUI extends JFrame {

    // Components
    JLabel labelCreate = new JLabel();
    JPanel panelCreate = new JPanel();
    JLabel labelCapacity = new JLabel();
    JTextField tfCapacity = new JTextField();
    JTextField tfLoadFactor = new JTextField();
    JLabel labelLoadFactor = new JLabel();
    JButton butonCreate = new JButton();
    JLabel labelEvents = new JLabel();
    JButton buttonAddKey = new JButton();
    JButton buttonRemoveKey = new JButton();
    JButton buttonChangeValue = new JButton();
    JButton buttonValue = new JButton();
    JButton buttonContainsKey = new JButton();
    JButton buttonContains = new JButton();
    JPanel panelActionInput = new JPanel();
    JLabel labelEvents1 = new JLabel();
    JTextField tfKey = new JTextField();
    JTextField tfValue = new JTextField();
    JLabel labelKey = new JLabel();
    JLabel labelValue = new JLabel();
    JPanel panelAction = new JPanel();
    JButton buttonSize = new JButton();
    JButton buttonString = new JButton();
    JButton buttonValues = new JButton();
    JButton buttonMakeEmpty = new JButton();
    JButton buttonIsEmpty = new JButton();
    JButton buttonKeys = new JButton();
    JLabel labelEvents2 = new JLabel();
    JScrollPane scrollPane = new JScrollPane();
    JTextArea taAction = new JTextArea();
    JComboBox selectBox = new JComboBox();

    // Models
    foundations.Dictionary d;


    //Construct the frame
    
    public DictionaryLabUI() {
        enableEvents(AWTEvent.WINDOW_EVENT_MASK);
        try  {
            jbInit();
        }
        catch (Exception e) {
            e.printStackTrace();
        }
    }

    //Component initialization

    private void jbInit() throws Exception  {
        this.setSize(new Dimension(569, 451));
        this.setTitle("Dictionary Laboratory");
        this.getContentPane().setLayout(null);
        labelCreate.setHorizontalTextPosition(SwingConstants.CENTER);
        labelCreate.setText("Constructor Options");
        labelCreate.setBounds(new Rectangle(217, 4, 126, 23));
        panelCreate.setBackground(new Color(255, 255, 200));
        panelCreate.setBounds(new Rectangle(48, 27, 465, 72));
        panelCreate.setLayout(null);
        labelCapacity.setBounds(new Rectangle(77, 14, 86, 23));
        labelCapacity.setText("Initial Capacity");
        tfCapacity.setBackground(Color.white);
        tfCapacity.setBounds(new Rectangle(167, 15, 84, 21));
        tfCapacity.setText("default");

        labelLoadFactor.setBounds(new Rectangle(3, 43, 160, 23));
        labelLoadFactor.setText("Load Factor (hashtable only)");
        tfLoadFactor.setBackground(Color.white);
        tfLoadFactor.setBounds(new Rectangle(167, 44, 84, 21));
        buttonAddKey.setText("addKeyVal");
        buttonAddKey.setBounds(new Rectangle(9, 35, 120, 23));
        buttonAddKey.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                buttonAddKey_actionPerformed(e);
            }
        });
        buttonAddKey.setOpaque(true);
        buttonRemoveKey.setBounds(new Rectangle(136, 35, 120, 23));
        buttonRemoveKey.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                buttonRemoveKey_actionPerformed(e);
            }
        });

        buttonRemoveKey.setOpaque(true);
        buttonChangeValue.setBounds(new Rectangle(9, 68, 120, 23));
        buttonChangeValue.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                buttonChangeValue_actionPerformed(e);
            }
        });
        
        buttonChangeValue.setOpaque(true);
        buttonValue.setBounds(new Rectangle(136, 68, 120, 23));
        buttonValue.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                buttonValue_actionPerformed(e);
            }
        });
        buttonValue.setOpaque(true);
        buttonContainsKey.setBounds(new Rectangle(9, 101, 120, 23));
        buttonContainsKey.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                buttonContainsKey_actionPerformed(e);
            }
        });
        buttonContainsKey.setOpaque(true);
        buttonContains.setBounds(new Rectangle(136, 101, 120, 23));
        buttonContains.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                buttonContains_actionPerformed(e);
            }
        });
        buttonContains.setOpaque(true);
        panelActionInput.setBackground(new Color(255, 250, 200));
        panelActionInput.setLayout(null);
        panelActionInput.setBounds(new Rectangle(10, 139, 265, 135));
        labelEvents1.setBounds(new Rectangle(63, 111, 141, 23));
        tfKey.setText("integer");
        tfKey.setBounds(new Rectangle(45, 6, 48, 19));
        tfValue.setBounds(new Rectangle(145, 6, 81, 19));
        labelKey.setText("Key");
        labelKey.setBounds(new Rectangle(15, 6, 29, 19));
        labelKey.setHorizontalTextPosition(SwingConstants.RIGHT);
        labelValue.setText("Value");
        labelValue.setBounds(new Rectangle(101, 6, 41, 19));
        panelAction.setBackground(new Color(255, 255, 200));
        panelAction.setLayout(null);
        panelAction.setBounds(new Rectangle(10, 301, 265, 109));
        buttonSize.setBounds(new Rectangle(9, 43, 120, 23));
        buttonSize.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                buttonSize_actionPerformed(e);
            }
        });
        buttonSize.setOpaque(true);
        buttonString.setBounds(new Rectangle(136, 43, 120, 23));
        buttonString.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                buttonString_actionPerformed(e);
            }
        });
        buttonString.setOpaque(true);
        buttonValues.setBounds(new Rectangle(136, 76, 120, 23));
        buttonValues.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                buttonValues_actionPerformed(e);
            }
        });
        buttonValues.setOpaque(true);
        buttonMakeEmpty.setMaximumSize(new Dimension(93, 23));
        buttonMakeEmpty.setText("makeEmpty");
        buttonMakeEmpty.setPreferredSize(new Dimension(93, 23));
        buttonMakeEmpty.setBounds(new Rectangle(9, 10, 120, 23));
        buttonMakeEmpty.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                buttonMakeEmpty_actionPerformed(e);
            }
        });
        buttonMakeEmpty.setOpaque(true);
        buttonMakeEmpty.setMinimumSize(new Dimension(93, 23));
        buttonIsEmpty.setBounds(new Rectangle(136, 10, 120, 23));
        buttonIsEmpty.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                buttonIsEmpty_actionPerformed(e);
            }
        });
        buttonIsEmpty.setOpaque(true);
        buttonKeys.setBounds(new Rectangle(9, 76, 120, 23));
        buttonKeys.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                buttonKeys_actionPerformed(e);
            }
        });
        buttonKeys.setOpaque(true);
        labelEvents2.setBounds(new Rectangle(54, 276, 159, 23));
        scrollPane.setBackground(Color.white);
        scrollPane.setBounds(new Rectangle(285, 139, 269, 273));
        selectBox.setBounds(new Rectangle(275, 13, 170, 24));
        selectBox.addItem("HashDictionary");
        selectBox.addItem("HashDictionaryE");
        selectBox.addItem("VectorDictionary");
        selectBox.addItem("VectorDictionaryE");
        selectBox.addItem("DictionaryE");
        labelEvents2.setText("Actions Requiring No Inputs");
        buttonKeys.setText("keys");
        buttonIsEmpty.setText("isEmpty");
        buttonValues.setText("values");
        buttonString.setText("toString");
        buttonSize.setText("size");
        labelValue.setHorizontalTextPosition(SwingConstants.RIGHT);
        tfValue.setText("String");
        labelEvents1.setText("Actions Requiring Inputs");
        buttonContains.setText("containsVal");
        buttonContainsKey.setText("containsKey");
        buttonValue.setText("valueFor(key)");
        buttonChangeValue.setText("changeValue");
        buttonRemoveKey.setText("removeKey");
        tfLoadFactor.setText("0.75");
        butonCreate.setBounds(new Rectangle(287, 42, 146, 24));
        butonCreate.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                butonCreate_actionPerformed(e);
            }
        });
        butonCreate.setText("Invoke Constructor");
        butonCreate.setOpaque(true);
        labelEvents.setBounds(new Rectangle(372, 111, 94, 23));
        labelEvents.setText("Result of Action");
        this.getContentPane().add(panelCreate, null);
        panelCreate.add(labelCapacity, null);
        panelCreate.add(tfLoadFactor, null);
        panelCreate.add(butonCreate, null);
        panelCreate.add(labelLoadFactor, null);
        panelCreate.add(tfCapacity, null);
        panelCreate.add(selectBox, null);
        this.getContentPane().add(labelEvents, null);
        this.getContentPane().add(labelEvents1, null);
        this.getContentPane().add(labelEvents2, null);
        this.getContentPane().add(scrollPane, null);
        scrollPane.getViewport().add(taAction, null);
    this.getContentPane().add(panelActionInput, null);
    panelActionInput.add(tfValue, null);
    panelActionInput.add(tfKey, null);
    panelActionInput.add(labelKey, null);
    panelActionInput.add(labelValue, null);
    panelActionInput.add(buttonAddKey, null);
    panelActionInput.add(buttonChangeValue, null);
    panelActionInput.add(buttonContainsKey, null);
    panelActionInput.add(buttonValue, null);
    panelActionInput.add(buttonContains, null);
    panelActionInput.add(buttonRemoveKey, null);
    this.getContentPane().add(panelAction, null);
    panelAction.add(buttonSize, null);
    panelAction.add(buttonString, null);
    panelAction.add(buttonValues, null);
    panelAction.add(buttonMakeEmpty, null);
    panelAction.add(buttonKeys, null);
    panelAction.add(buttonIsEmpty, null);
    this.getContentPane().add(labelCreate, null);
        enableButtons(false);
    }
//Overriden so we can exit on System Close
    
    protected void processWindowEvent(WindowEvent e) {
        super.processWindowEvent(e);
        if (e.getID() == WindowEvent.WINDOW_CLOSING) {
            System.exit(0);
        }
    }

    // Supporting methods
    void enableButtons(boolean b){
        buttonAddKey.setEnabled(b);
        buttonRemoveKey.setEnabled(b);
        buttonChangeValue.setEnabled(b);
        buttonValue.setEnabled(b);
        buttonContainsKey.setEnabled(b);
        buttonContains.setEnabled(b);
        buttonSize.setEnabled(b);
        buttonString.setEnabled(b);
        buttonValues.setEnabled(b);
        buttonMakeEmpty.setEnabled(b);
        buttonIsEmpty.setEnabled(b);
        buttonKeys.setEnabled(b);
    }

    void clearTextFields(){
         tfKey.setText("");
         tfValue.setText("");
    }

    void initTextFields(){
         tfKey.setText("integer");
         tfValue.setText("string");
    }

    void createHashDictionary(boolean exercise) {
        initTextFields();
        int capacity = -1;
        float loadFactor = 0.75f;
        taAction.setText("");;
        try {
            capacity = (new Integer(tfCapacity.getText())).intValue();
        } catch (Exception ex) {
            capacity = -1;
        }
        try {
            loadFactor = (new Float(tfLoadFactor.getText())).floatValue();
        } catch (Exception ex) {
            taAction.append("Error in loadFactor\n");
            return;
        }
        if (capacity == -1){   // default constructor
           try {
               if (exercise){
                   d = new HashDictionaryE();
                   taAction.append("Created default HashDictionaryE\n");
               } else {
                   d = new HashDictionary();
                   taAction.append("Created default HashDictionary\n");
               }
               enableButtons(true);
           } catch (Exception ex) {
               taAction.append("Error in creating HashDictionary\n");
           }
        }
        else {       // specify capacity and loadFactor
           try {
               if (exercise){
                   d = new HashDictionaryE(capacity, loadFactor);
                   taAction.append("Created custom HashDictionaryE\n");
               } else {
                   d = new HashDictionary(capacity, loadFactor);
                   taAction.append("Created custom HashDictionary\n");
               }
               enableButtons(true);
           } catch (Exception ex) {
               taAction.append("Error in creating HashDictionary\n");
           }
        }
    }

    void createVectorDictionary(boolean exercise) {
        initTextFields();
        int capacity = -1;
        taAction.setText("");;
        try {
            capacity = (new Integer(tfCapacity.getText())).intValue();
        } catch (Exception ex) {
            capacity = -1;
        }
        if (capacity == -1){   // default constructor
           try {
               if (exercise){
                   d = new VectorDictionaryE();
                   taAction.append("Created default VectorDictionaryE\n");
               } else {
                   d = new VectorDictionary();
                   taAction.append("Created default VectorDictionary\n");
               }
               enableButtons(true);
           } catch (Exception ex) {
               taAction.append("Error in creating VectorDictionary\n");
           }
        }
        else {                 // specify capacity
           try {
               if (exercise){
                   d = new VectorDictionaryE(capacity);
                   taAction.append("Created custome VectorDictionaryE\n");
               } else {
                   d = new VectorDictionary(capacity);
                   taAction.append("Created custom VectorDictionary\n");
               }
               enableButtons(true);
           } catch (Exception ex) {
               taAction.append("Error in creating VectorDictionary\n");
           }
        }
    }

    void createDictionaryE() {
        initTextFields();
        int capacity = -1;
        taAction.setText("");;
        try {
            capacity = (new Integer(tfCapacity.getText())).intValue();
        } catch (Exception ex) {
            capacity = -1;
        }
        if (capacity == -1){   // default constructor
           try {
               d = new DictionaryE();
               taAction.append("Created default DictionaryE\n");
               enableButtons(true);
           } catch (Exception ex) {
               taAction.append("Error in creating DictionaryE\n");
           }
        }
        else {                 // specify capacity
           try {
               d = new DictionaryE(capacity);
               taAction.append("Created custom DictionaryE\n");
               enableButtons(true);
           } catch (Exception ex) {
               taAction.append("Error in creating DictionaryE\n");
           }
        }
    }

    // event handling methods

    void buttonAddKey_actionPerformed(ActionEvent e) {
        int key;
        try {
            key = (new Integer(tfKey.getText())).intValue();
        } catch (Exception ex) {
            taAction.append("Key must be an integer\n");
            return;
        }
        d.addKey(new Integer(key), tfValue.getText());
        taAction.append("Added <" + key + ":" + tfValue.getText() + ">\n");
        clearTextFields();
    }

    void buttonChangeValue_actionPerformed(ActionEvent e) {
        int key;
        try {
            key = (new Integer(tfKey.getText())).intValue();
        } catch (Exception ex) {
            taAction.append("Key must be an integer\n");
            return;
        }
        try {
        	d.changeValue(new Integer(key), tfValue.getText());
        	taAction.append("Changed value <" + key + ":" + tfValue.getText() + ">\n");
        } catch (Exception ex) {
        	taAction.append("NoSuchElementException: " + ex.getMessage() + "\n");
        }
        clearTextFields();
    }

    void buttonContainsKey_actionPerformed(ActionEvent e) {
        int key;
        try {
            key = (new Integer(tfKey.getText())).intValue();
        } catch (Exception ex) {
            taAction.append("Key must be an integer\n");
            return;
        }
        taAction.append("Key: " + key + " is" +
                  ((d.containsKey(new Integer(key))) ? "" : " not") + " found\n");
        clearTextFields();
    }

    void buttonRemoveKey_actionPerformed(ActionEvent e) {
        int key;
        try {
            key = (new Integer(tfKey.getText())).intValue();
        } catch (Exception ex) {
            taAction.append("Key must be an integer\n");
            return;
        }
        d.removeKey(new Integer(key));
        taAction.append("Key: " + key + " was removed\n");
        clearTextFields();
    }

    void buttonValue_actionPerformed(ActionEvent e) {
        int key;
        try {
            key = (new Integer(tfKey.getText())).intValue();
        } catch (Exception ex) {
            taAction.append("Key must be an integer\n");
            return;
        }
        try {
            String str = (String) d.valueFor(new Integer(key));
            taAction.append("Key: " + key + " has value: " + str + "\n");
            clearTextFields();
        } catch (Exception ex) {
            taAction.append("NoSuchElementException: " + ex.getMessage() + "\n");
        }

    }

    void buttonContains_actionPerformed(ActionEvent e) {
        String value = tfValue.getText();
        taAction.append("Value: " + value + " is" +
                  ((d.containsValue(value)) ? "" : " not") + " found\n");
        clearTextFields();
    }

    void buttonMakeEmpty_actionPerformed(ActionEvent e) {
        d.makeEmpty();
        taAction.append("Dictionary is now empty\n");
        clearTextFields();
    }

    void buttonSize_actionPerformed(ActionEvent e) {
        taAction.append("Dictionary has size = " + d.size() + "\n");
        clearTextFields();
    }

    void buttonIsEmpty_actionPerformed(ActionEvent e) {
        taAction.append("Dictionary " + " is" +
                  ((d.isEmpty()) ? "" : " not") + " empty\n");
        clearTextFields();
    }

    void buttonString_actionPerformed(ActionEvent e) {
        taAction.append("contents = " + d + "\n");
        clearTextFields();
    }

    void buttonKeys_actionPerformed(ActionEvent e) {
        if (d.isEmpty())
           taAction.append("keys = { }\n");
        else {
            String str = "keys = { ";
            for ( Iterator i = d.keys(); i.hasNext();)
                str = str + i.next() + ", ";
            taAction.append(str.substring(0, str.length() -2) + " }\n");
        }
        clearTextFields();
    }

    void buttonValues_actionPerformed(ActionEvent e) {
        if (d.isEmpty())
           taAction.append("values = { }\n");
        else {
            String str = "values = { ";
            for ( Iterator i = d.values(); i.hasNext();)
                str = str + i.next() + ", ";
            taAction.append(str.substring(0, str.length() -2) + " }\n");
        }
        clearTextFields();
    }

    void butonCreate_actionPerformed(ActionEvent e) {
        taAction.setText("");
        int i = selectBox.getSelectedIndex();
        if (i == 0)
            createHashDictionary(false);
        else if (i == 1)
            createHashDictionary(true);
        else if (i == 2)
            createVectorDictionary(false);
        else if (i == 3)
            createVectorDictionary(true);
        else if (i == 4)
            createDictionaryE();
        tfKey.requestFocus();
    }
}

