/**
  * Game class that holds the players and initiates action
*/

public class Game {

    // Fields
    private Player [] players = new Player[5]; // Use natural indexing
    private java.util.Random rnd = new java.util.Random();
    private int numberPlayers;
    
    // Constructor
    public Game (int numberPlayers) {
    		this.numberPlayers = numberPlayers;
        	// Warm up random number generator
        	for (int i = 0; i < 50000; i++)
         	rnd.nextDouble();
        	// Create four Player objects
        	players[1] = new Player(1, rnd);
        	players[2] = new Player(2, rnd);
        	players[3] = new Player(3, rnd);
        	players[4] = new Player(4, rnd);
       
        	// Assign random Response type to each player
        	for (int playerNumber = 1; playerNumber <= numberPlayers; 
                                   playerNumber++)
         	assignRandomResponse(players[playerNumber]);
    }

    // Command
    public void assignRandomResponse (Player player) {
        // Assign a random Response object to specified player
        switch (1 + rnd.nextInt(3)) {
            case 1: // Player gets TypeOneResponse
                player.assignResponse(new TypeOneResponse(players, 
                               	numberPlayers, player.playerNumber()));
                break;
            case 2: // Player gets TypeTwoResponse
                player.assignResponse(new TypeTwoResponse(players, 
            					numberPlayers, player.playerNumber()));
                break;
            case 3: // Player gets TypeThreeResponse
                player.assignResponse(new TypeThreeResponse(players, 
 							numberPlayers, player.playerNumber()));
                break;
        }
    }






    public void play () {  
    		int playerNumber = 0;
        	do {
         	playerNumber++;
            	if (playerNumber > numberPlayers)
              	playerNumber = 1;
           
            	if (players[playerNumber].responseLife() == 0) 
                	assignRandomResponse(players[playerNumber]);
            
            	players[playerNumber].makeMove(1 + rnd.nextInt(6));
            	System.out.println("Player " + playerNumber + 
				" position: " + players[playerNumber].position());
        } while (!players[playerNumber].wins());
        System.out.println("\n\nPlayer " + playerNumber + 
 						" wins the game.");
    }

    public static void main(String[] args) {
        Game game = new Game(4);
        game.play();
    }
}
