/**
  * Abstract class that models change in position
*/
public abstract class Response {

    // Fields
    protected Player [] players; // The players in the game
    protected int numberPlayers; // Number of players in the game
    protected int playerNumber;  // Player associated with Response 

    // Constructor
    public Response (Player [] players, int numberPlayers, 
 				   int playerNumber) {
        this.players = players;
        this.numberPlayers = numberPlayers;
        this.playerNumber = playerNumber;
    }

    // Queries
    /**
      * Returns the player's change in position based on move
    */
    public abstract int changeInPosition(int dieThrow);
}
