/** class CounterBean - MVC Delegation Example 
*/
import java.beans.*;

public class CounterBean extends Object {

    protected PropertyChangeSupport propertyChange = new PropertyChangeSupport(this);
    protected int count = 0;

    /** supporting commands for registration of listeners 
     */
    public synchronized void addPropertyChangeListener (PropertyChangeListener listener) {
        propertyChange.addPropertyChangeListener(listener);
    }

    public synchronized void removePropertyChangeListener (PropertyChangeListener listener) {
        propertyChange.removePropertyChangeListener(listener);
    }

    // model commands
    public void setCount (int anInt) {
        count = anInt;
        propertyChange.firePropertyChange("count", null, null);		
    }

    
    public void increment () {
        setCount(count + 1);
    }	

    public void reset () {
        setCount(0);
    }

    // queries
    public int getCount () {
        return count;
    }
}
