/** Simple Event-Driven GUI Application
 *  File: EventExampleUI.java
 * 
 *  Revised: 3/16/99
*/

import java.awt.*;
import java.awt.event.*;

public class EventExampleUI extends Frame implements ActionListener {

    Label valueLabel;
    Button incrementButton;
    Button resetButton;
    
    public EventExampleUI () {
        super("An Incrementer");
        addWindowListener(new WindowAdapter() {
	    	public void windowClosing(WindowEvent evt) {System.exit(0);}});
        initialize();
    }

    private void initialize () {
    	setSize(200, 100);
    	this.setLayout(null);
    	incrementButton = new Button("Increment");
    	incrementButton.setBounds(20, 40, 75, 25);
        incrementButton.addActionListener(this);
        add(incrementButton);
        resetButton = new Button("Reset");
        resetButton.setBounds(105, 40, 75, 25);
        resetButton.addActionListener(this);
        add(resetButton);
        valueLabel = new Label("0", Label.CENTER);
        valueLabel.setBounds(75, 70, 50, 25);
        add(valueLabel);
        setVisible(true);
    }

    
    
    public void actionPerformed (ActionEvent evt) {
        if (evt.getSource() == incrementButton){
            int value = (new Integer(valueLabel.getText())).intValue();    
            valueLabel.setText(String.valueOf(value + 1));
        } else if (evt.getSource() == resetButton)
            valueLabel.setText("0");
    }

    public static void main (String[] args) {
	   new EventExampleUI();
    }
}
