/** Simple Event-Driven GUI Application
 *  File: EventExampleUI.java
 * 
 *  Revised: 3/16/99
*/

import java.awt.*;
import java.awt.event.*;

public class EventExampleUI4 extends Frame {

    Label valueLabel;
    Button incrementButton;
    Button resetButton;
    
    public EventExampleUI4 () {
        super("An Incrementer");
        addWindowListener(new WindowAdapter() {
	    	public void windowClosing(WindowEvent evt) {System.exit(0);}});
        initialize();
    }

    private void initialize () {
    	setSize(200, 100);
    	this.setLayout(null);
    	incrementButton = new Button("Increment");
    	incrementButton.setBounds(20, 40, 75, 25);
    	incrementButton.addActionListener( 
    		new IncrementButtonEventHandler(this));
        add(incrementButton);
        resetButton = new Button("Reset");
        resetButton.setBounds(105, 40, 75, 25);
        resetButton.addActionListener( new ActionListener(){
    		public void actionPerformed(ActionEvent evt){  
            	valueLabel.setText("0");
        }});
        add(resetButton);
        valueLabel = new Label("0", Label.CENTER);
        valueLabel.setBounds(75, 70, 50, 25);
        add(valueLabel);
        setVisible(true);
    }

    public static void main (String[] args) {
	   new EventExampleUI4();
    }
}

class IncrementButtonEventHandler implements ActionListener {

	EventExampleUI4 frame;
	
	public IncrementButtonEventHandler (EventExampleUI4 f) {
		frame = f;
	}
	
	public void actionPerformed (ActionEvent evt) {
   		int value = (new Integer(frame.valueLabel.getText())).intValue();    
       	frame.valueLabel.setText(String.valueOf(value + 1));
    }
}
