/** Advertising exceptions
*/
import java.io.*;
import java.util.*;

public class Advertise {

	int value = 6;

	// cloning
	public void required () throws CloneNotSupportedException {
		Advertise ad = (Advertise) this.clone();
	}

	//array index
	public void notRequired () {
		int [] array = new int[3];
		array[3] = 25;
	}

	// instantiation
	public void mixed (String name) throws  ClassNotFoundException,
											InstantiationException, 
											IllegalAccessException {	
		// method newInstance() also throws runtime exceptions (no need to advertise)
		// ExceptionInInitializerError, SecurityException

		System.out.println("New instance of " + name + ": " + Class.forName(name).newInstance());
	}

	static public void main (String [] args) throws CloneNotSupportedException,
													ClassNotFoundException, 
													InstantiationException, 
													IllegalAccessException, 
													IOException {
 
		BufferedReader keyboard = new BufferedReader(new InputStreamReader(System.in));
		Advertise ad = new Advertise();

		System.out.println("Cloning--------- 1");
		System.out.println("Array index----- 2");
		System.out.println("Instantiation--- 3");
		System.out.print("\nEnter number: ");
		String choice = keyboard.readLine();
		System.out.println(choice);

		if (choice.equals("1"))
			ad.required();
		else if (choice.equals("2"))
			ad.notRequired();
		else if (choice.equals("3")) {
			System.out.print("Enter a class name: ");
			String name = keyboard.readLine();
			ad.mixed(name);
		}
		else
			throw new NoSuchElementException("No such choice");
	}
}
