/** Generates various kinds of exceptions
*/
import java.io.*;

public class ExceptionGenerator {

    // Fields
    Counter myCounter;

    // Commands
    public void incrementCounter () {
        // Generate a NullPointerException
        myCounter.increment();
    }

    public void divideByZero () {
        // Generate an ArithmeticException
        int y = 6, x = 0;
        int z = y / x;
        System.out.println ("z = " + z);
    }

    public void arrayOutOfBounds () {
        // Generate an ArrayIndexOutOfBoundsException
        int [] data = new int [10];
        data[10] = 16;
        System.out.println ("data[10] = " + data[10]);
    }

    public void badCast () throws IOException {
        // Generate a NumberFormatException
        BufferedReader keyboard = new BufferedReader (
                                  new InputStreamReader (System.in));
        System.out.print ("Enter an integer: ");
        String line = keyboard.readLine();
        int value = (new Integer(line)).intValue();
        System.out.println("value = " + value);
    }

    public void numericInput () {
        try {
            // Have user input a string representing a number
            BufferedReader keyboard = new BufferedReader (
                                  new InputStreamReader(System.in));
            System.out.print ("Enter an integer: ");
            String line = keyboard.readLine();
            int value = (new Integer(line)).intValue();
            System.out.println("value = " + value);
        }
        catch (IOException ex) {
            System.out.println ("IO exception in reading user input.");
        }
        catch (NumberFormatException ex) {
            System.out.println ("Invalid integer entered.");
        }
    }

    public void numericInputWithException () {
        try {
            // Have user input a string representing a number
            BufferedReader keyboard = new BufferedReader (
                                   new InputStreamReader (System.in));
            System.out.print ("Enter an integer: ");
            String line = keyboard.readLine();
            int value = (new Integer(line)).intValue();
            System.out.println("value = " + value);
        }
        catch (IOException ex) {
            System.out.println ("IO exception in reading user input.");
        }
    }
}
