/** Illustrates exception handling
*/
import java.io.*;

public class ExceptionsApp {

    // Fields
    ExceptionGenerator except = new ExceptionGenerator();
    int choice;
    BufferedReader keyboard = new BufferedReader(
    							new InputStreamReader(System.in));

    // Commands
    public void generateExceptions () {
        System.out.println ("1 --> Null pointer");
        System.out.println ("2 --> Divide by zero");
        System.out.println ("3 --> Array index range error");
        System.out.println ("4 --> Bad cast");
        System.out.println ("5 --> Bad numeric input");
        System.out.println ("6 --> Trap bad numeric input");
        System.out.print("Enter choice: ");
        try {
        	choice = (new Integer(keyboard.readLine())).intValue();
        }
        catch (IOException ex) { // do nothing 
        }
        switch (choice) {
            case 1:
                except.incrementCounter();
                break;
            case 2:
                except.divideByZero();
                break;
            case 3:
                except.arrayOutOfBounds();
                break;
            case 4:
                try {
                    except.badCast();
                }
                catch (IOException ex) {} // Unhandled exception
                break;
            case 5:
                except.numericInput();
                break;
            case 6:
                try {
                    except.numericInputWithException();
                }
                catch (NumberFormatException ex) {
                    try {
					 // Second and final chance
                        except.numericInputWithException(); 
                    }
                    catch (Exception e) {}
                }
                finally {
            		System.out.println ("In finally block.");
        		}
                break;
        }
    }

    public static void main (String[] args) {
        ExceptionsApp app = new ExceptionsApp();
        app.generateExceptions();
    }
}
