/** File Recursion1.java 
*   - illustrating several properties/applications of single recursion
*/
import java.io.*;

public class Recursion1{

	// print string, count times
	public void replicator (String string, int count) {
	  	if ( count > 0 ){
	    	System.out.println( "Count = " + count + ", string is: " + string);
    		replicator( string, count - 1 );
	  	}
	}
/*
Test of recursive function, replicator
Count = 10, string is: Hello
Count = 9, string is: Hello
Count = 8, string is: Hello
Count = 7, string is: Hello
Count = 6, string is: Hello
Count = 5, string is: Hello
Count = 4, string is: Hello
Count = 3, string is: Hello
Count = 2, string is: Hello
Count = 1, string is: Hello
*/

	// return the factorial of num
	public double factorial (double num) {
	  	if ( num > 0.0 )
			if ( num == 1 )
				return 1.0;
	    	else
				return( num * factorial( num - 1 ) );
	  	else {
	    	System.out.println( "Factorial not defined for negative numbers" );
    		return 0.0;
	  	}	
	}
/*
Test of factorial recursive function
The factorial of 6 is: 720.0
*/

	// return the average of size numbers in inArray
	public double average (double[] inArray, int size) {
  		int index = size - 1;
  		if ( size == 1 )
    		return inArray[index];
  		else
    		return inArray[index] / size + (size - 1.0)/size
				 * average( inArray, size - 1 );
	}
/*
Test of recursive average function
The average of 8 numbers in inArray is: 22.5
*/

	// first statement is recursive call
	public void earlycall (int val) {
  		if ( val != 0 ){
    		earlycall( val / 2 );
    		System.out.println( "val = " + val );
  		}
	}
/*
Test of recursive call as first statement
val = 1
val = 2
val = 4
val = 8
val = 16
val = 32
val = 64
val = 128
val = 256
*/

	// last statement is recursive call
	public void latecall (int val) {
  		if ( val != 0 ){
    		System.out.println( "val = " + val );
    		latecall( val / 2 );
  		}
	}
/*
Test of recursive call as last statement
val = 256
val = 128
val = 64
val = 32
val = 16
val = 8
val = 4
val = 2
val = 1
*/

	// return largest int in inArray
	public double findlargest (double[] inArray, int size) {
  		double temp;
  		int index = size - 1;

  		if ( size == 1 )
    		return inArray[ 0 ];
  		else{
    		temp = findlargest( inArray, size - 1 );
    		if ( temp > inArray[ index ] )
	 			return temp;
   			 else
	 			return inArray[ index ];
  		}
	}
/*
Test of recursive function to find largest in array
The largest of 8 numbers in inArray is: 40.0
*/

	// use binary search to find val in sorted inArray
	// return index in array of val if found; -1 if not found
	public int binsearch (double[] inArray, double val, int size) {
  		return binarysearch( inArray, val, 0, size-1 );
	}

	// recursively searches for index of val in inArray between low and high
	private int binarysearch (double[] inArray, double val, int low, int high) {
		int mid;
  		if ( low > high )
    		return -1;          // val not in inArray
  		else {
		    mid = ( low + high ) / 2;
		    if ( val == inArray[ mid ] )
				return mid;
	    	else {
	 			if ( val < inArray[ mid ] )
	   				return binarysearch( inArray, val, low, mid - 1 );
			 	else
	   				return binarysearch( inArray, val, mid + 1 , high );
    		}
  		}
	}
/*
Test of binary search for val in a sorted array
Binary search for value = 20.0 gives index = 3 (-1 means not found)
Binary search for value = 12.0 gives index = -1 (-1 means not found)
*/

	public static void main (String[] args) throws IOException {
  		String   greeting = "Hello";
  		int      count    = 10;
  		int      num      = 6;
  		int      size     = 8;
  		double[] inArray;
  		int      val      = 256;
  		double   value;
  		Recursion1 recursion = new Recursion1();

  		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
  		System.out.print("Enter time delay between experiments (seconds): ");
  		int sec = new Integer(br.readLine()).intValue();

  		// test of recursive function, replicator
		System.out.println( "Test of recursive function, replicator\n" );
  		recursion.replicator( greeting, count );
  		Recursion1.pause(sec);

  		// test of recursive function, factorial
  		System.out.println( "Test of factorial recursive function\n" );
  		System.out.println( "The factorial of " + num + " is: " + recursion.factorial( num ));
  		Recursion1.pause(sec);

  		// test of recursive function, average
  		System.out.println( "Test of recursive average function\n" );
  		inArray = new double[size];
  		for ( int i = 0; i < size; i++ )
	 		inArray[ i ] = 5.0 * ( i + 1 );
    	System.out.println( "The average of " + size + " numbers in inArray is: " 
    		+ recursion.average( inArray, size ) );
  		Recursion1.pause(sec);

  		// Test of recursive function, earlycall
  		System.out.println("Test of recursive call as first statement\n" );
  		recursion.earlycall( val );
  		Recursion1.pause(sec);

  		// Test of recursive function, latecall
  		System.out.println("Test of recursive call as last statement\n" );
  		recursion.latecall( val );
  		Recursion1.pause(sec);

  		// Test of recursive function for findlargest
  		System.out.println("Test of recursive function to find largest in array\n" );
   		System.out.println( "The largest of " + size + " numbers in inArray is: "
		 	+ recursion.findlargest( inArray, size ) );
        Recursion1.pause(sec);

  		// Test of recursive function for binary search
  		System.out.println( "Test of binary search for val in a sorted array\n");
	  	value = 20.0;
  		System.out.println( "Binary search for value = " + value + " gives index = "
  				+ recursion.binsearch( inArray, value, size ) + " (-1 means not found)");
  		value = 12.0;
  		System.out.println( "Binary search for value = " + value + " gives index = "
  				+ recursion.binsearch( inArray, value, size ) + " (-1 means not found)");
  		Recursion1.pause(sec);
	}

  	public static void pause (int seconds) {
        System.out.println("---wait " + seconds + " seconds---");
        long time = System.currentTimeMillis();
        while(System.currentTimeMillis() - time < 1000 * seconds){}
        System.out.println();
    }
}

/* Typical output for 0 second delay

Enter time delay between experiments (seconds): 0
Test of recursive function, replicator
Count = 10, string is: Hello
Count = 9, string is: Hello
Count = 8, string is: Hello
Count = 7, string is: Hello
Count = 6, string is: Hello
Count = 5, string is: Hello
Count = 4, string is: Hello
Count = 3, string is: Hello
Count = 2, string is: Hello
Count = 1, string is: Hello
---wait 0 seconds---

Test of factorial recursive function
The factorial of 6 is: 720.0
---wait 0 seconds---

Test of recursive average function
The average of 8 numbers in inArray is: 22.5
---wait 0 seconds---

Test of recursive call as first statement
val = 1
val = 2
val = 4
val = 8
val = 16
val = 32
val = 64
val = 128
val = 256
---wait 0 seconds---

Test of recursive call as last statement
val = 256
val = 128
val = 64
val = 32
val = 16
val = 8
val = 4
val = 2
val = 1
---wait 0 seconds---

Test of recursive function to find largest in array
The largest of 8 numbers in inArray is: 40.0
---wait 0 seconds---

Test of binary search for val in a sorted array
Binary search for value = 20.0 gives index = 3 (-1 means not found)
Binary search for value = 12.0 gives index = -1 (-1 means not found)
---wait 0 seconds---


*/

