/** A simple class to illustrate double recursion
*/
import java.io.*;

public class Recursion2 {

	// illustrate double recursion by printing values
	public void inOrderPrint (int index) {
		if (index > 0){
			inOrderPrint(index/2);
			System.out.println("Index = " + index);
			inOrderPrint(index/2);
		}
	}

	// compute and display all permutations of an array of characters
	// uses a variation of double recursion
	public void permute (char[] inArray, int size) {
		int index = size - 1;
		char temp;

		if (size > 1){
			permute(inArray, index);
			for (int i = index - 1; i >= 0; i--){
				temp = inArray[index];
				inArray[index] = inArray[i];
				inArray[i] = temp;
				permute(inArray, index);
				temp = inArray[index];
				inArray[index] = inArray[i];
				inArray[i] = temp;
			}
		} else {
			for (int j = 0; j < inArray.length; j++)
				System.out.print(inArray[j]);
			System.out.println();
		}
	}

	public static void main (String[] args) throws IOException {
		char[] inArray;
		int index; 
		Recursion2 recurse = new Recursion2();
		
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		
		System.out.print("Enter an index (int) for doubly-recursive print: ");
		index = (new Integer(br.readLine())).intValue();
		recurse.inOrderPrint(index);

		System.out.print("Enter a string for permutation (keep it short): ");
		String str = br.readLine();
		inArray = new char[str.length()];
		str.getChars(0, str.length(), inArray, 0);	// copy str into inArray
		recurse.permute(inArray, inArray.length);
	}
}













/* output
Enter an index (int) for doubly-recursive print: 7
Index = 1
Index = 3
Index = 1
Index = 7
Index = 1
Index = 3
Index = 1

Enter a string for permutation (keep it short): abcd
abcd
bacd
acbd
cabd
cbad
bcad
abdc
badc
adbc
dabc
dbac
bdac
adcb
dacb
acdb
cadb
cdab
dcab
dbca
bdca
dcba
cdba
cbda
bcda
*/
