import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class CounterGUI extends JFrame {
  JButton reset = new JButton();
  JButton increment = new JButton();
  JLabel countLbl = new JLabel();
  Counter counter = new Counter();

  //Construct the frame
  public CounterGUI() {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try  {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  //Component initialization
  private void jbInit() throws Exception  {
    reset.setText("Reset");
    reset.setBounds(new Rectangle(139, 60, 92, 27));
    reset.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        reset_actionPerformed(e);
      }
    });
    this.getContentPane().setLayout(null);
    this.setSize(new Dimension(400, 300));
    this.setTitle("Counter Application in JBuilder");
    increment.setText("Increment");
    increment.setBounds(new Rectangle(139, 129, 92, 27));
    increment.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        increment_actionPerformed(e);
      }
    });
    countLbl.setText("Count: 0");
    countLbl.setBounds(new Rectangle(139, 192, 92, 17));
    this.getContentPane().add(reset, null);
    this.getContentPane().add(countLbl, null);
    this.getContentPane().add(increment, null);
  }

  //Overridden so we can exit on System Close
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if(e.getID() == WindowEvent.WINDOW_CLOSING) {
      System.exit(0);
    }
  }

  void increment_actionPerformed(ActionEvent e) {
    counter.increment();
    countLbl.setText ("Count: " + counter.countValue());
  }

  void reset_actionPerformed(ActionEvent e) {
    counter.reset();
    countLbl.setText ("Count: " + counter.countValue());
  }
}
