/** Class Fraction
*/
import java.io.Serializable;

public final class Fraction extends Number implements Comparable {

	// Fields
	private long numerator;
	private long denominator;
	
	// Constructors
	public Fraction () {}

	public Fraction (long num, long denom) {}

	public Fraction (long num) {}

	public Fraction (String fString) {
		try {
        	stringToFraction(fString);
        } catch (NumberFormatException ex) {
        	throw new NumberFormatException("Error in fraction string");
        }
	}

	// Commands
	public void setNumerator (long num) {
	}

	public void setDenominator (long denom) {
	}

	// Queries - fields
	public long numerator () {
		return numerator;
	}

	public long denominator () {
		return denominator;
	}

	// Queries - arithmetic operations
	public Fraction add (Fraction f) {
		return null; // exercise
	}

	public Fraction subtract (Fraction f) {
		return null;
	}

	public Fraction multiply (Fraction f) {
		return null;
	}

	public Fraction divide (Fraction f) {
		return null;
	}

	// Queries - comparisons
	public boolean equals (Object obj) {
		return false; // exercise
	}

	public int compareTo (Object obj) {
		return 0; // exercise
	}

	// Queries - conversions
	public int intValue () {
		return 0; // exercise
	}

	public long longValue () {
		return 0;	 // exercise
	}

	public float floatValue () {
		return 0.0f;	 // exercise
	}

	public double doubleValue () {
		return 0.0; // exercise	
	}

	public String toString () {
		return ""; // exercise
	}

	public int hashCode () {
		long bits = Double.doubleToLongBits(this.doubleValue());
		return (int) (bits ^ (bits >> 32));
	}

	// Private methods	
	private Fraction simplify () {
		long gcd = 0L;
		// set gcd to smaller of numerator or denominator
        if ( Math.abs( numerator ) > Math.abs( denominator ) )
            gcd = Math.abs( denominator );
        else
            gcd = Math.abs( numerator );
        if ( gcd == 0 )
            return this;
        while ( ( gcd != 1 ) && (( numerator % gcd != 0 ) || ( denominator % gcd != 0 )) )
        	gcd--;
        numerator /= gcd;
        denominator /= gcd;
        return this;
	}

	private void stringToFraction (String fString) { 
		int index = fString.indexOf("/");
		if (index == -1){
			try {
				numerator = (Long.valueOf(fString)).longValue();
				denominator = 1;
			} catch (NumberFormatException ex) {
				throw new NumberFormatException("Error in fraction string");
			}
		} 
		else {
			if (index == fString.lastIndexOf("/")){
				try {
					setNumerator((Long.valueOf(fString.substring(0, index).trim())).longValue());
					setDenominator((Long.valueOf(fString.substring(index + 1, fString.length()).trim())).longValue());
				} catch (NumberFormatException ex) {
					throw new NumberFormatException("Error in fraction string");
				}
			} 
			else
				throw new NumberFormatException("Error in fraction string");
		}
	}

	/** Short main function to test elements of <code>Fraction</code>.
	*  Output is as follows:
	*  <p>
	*	<p>The value of f1 is: 2/3
	*  <p>The value of f2 is: -3/4
	*  <p>The value of f3 is: 5/1
	*  <p>The value of f4 is: -8/9
	*  <p>The value of f5 is: 2/3
	*  <p>The value of f6 is: 0/0
	*  <p>The value of f7 is: -9/8
	*  <p>
	*  <p>The sum of f1 + f2 is: -1/12
	*  <p>The difference of f1 - f2 is: 17/12
	*  <p>The product of f1 * f2 is: -1/2
	*  <p>The quotient of f1 / f2 is: -8/9
	*  <p>f1.equals(f5) is: true
	*  <p>f4.compareTo(f2) = -1
	*  <p>
	*  <p>The hashcode for f1 is: 1789919232
	*  <p>The intValue of f4 is: 0
	*  <p>The intValue of f7 is: -1
	*  <p>The longValue of f4 is: 0
	*  <p>The floatValue of f4 is: -0.8888889
	*  <p>The doubleValue of f4 is: -0.8888888888888888
	*/

	public static void main (String[] args) {
		Fraction f1 = new Fraction(2, 3),
				 f2 = new Fraction(-3, 4),
				 f3 = new Fraction(5),
				 f4 = new Fraction("-8/9"),
				 f5 = new Fraction(8, 12),
				 f6 = new Fraction(),
				 f7 = new Fraction(9, -8);

        System.out.println("The value of f1 is: " + f1);
        System.out.println("The value of f2 is: " + f2);
        System.out.println("The value of f3 is: " + f3);
        System.out.println("The value of f4 is: " + f4);
        System.out.println("The value of f5 is: " + f5);
        System.out.println("The value of f6 is: " + f6);
        System.out.println("The value of f7 is: " + f7);
        System.out.println("\nThe sum of f1 + f2 is: " + f1.add(f2));
	    System.out.println("The difference of f1 - f2 is: " + f1.subtract(f2));
	    System.out.println("The product of f1 * f2 is: " + f1.multiply(f2));
	    System.out.println("The quotient of f1 / f2 is: " + f1.divide(f2));
	    System.out.println("f1.equals(f5) is: " + f1.equals(f5));		// should be true
	    System.out.println("f4.compareTo(f2) = " + f4.compareTo(f2)); // should be -1
	    System.out.println("\nThe hashcode for f1 is: " + f1.hashCode());
	    System.out.println("The intValue of f4 is: " + f4.intValue());
	    System.out.println("The intValue of f7 is: " + f7.intValue());
	 	System.out.println("The longValue of f4 is: " + f4.longValue());
	    System.out.println("The floatValue of f4 is: " + f4.floatValue());
	 	System.out.println("The doubleValue of f4 is: " + f4.doubleValue());
	}
}
